_me = frm_call.prototype;
function frm_call(){};

/**
 * @brief
 * 
 * @see  objects/frm_select_folder.xml
 * @see  inc/frm_select_folder.js
 * @see  forms/select_folder.xml
 * @see  inc/obj_context_folder.js
 * @see  inc/obj_context_item.js    
 */         
_me.__constructor = function(sContact,bEst,bVideo) {
	var me = this;

    this._resizable  = false;
	this._size(450,110,true);

	var sip;
	if (!(sip = gui.frm_main.sip)){
		this._destruct();
		return;
	}

	this._title(getLang('SIP::INCOMINGCALL',[sContact]),true);
	
    this._draw('frm_confirm', 'main');

	sip._add_callbeck ([this, '_execute']);

	this.obj_label._listen('sip',['info']);

	// Create 'OK' button
    if (!bEst){
		this._create('btn_ok', 'obj_button', 'footer');
		this.btn_ok._value('DIAL::ANSWER');
	    this.btn_ok._tabindex(5000);
		this.btn_ok._onclick = function() {
			sip._answerCall();
		};


        if (oWM_INIT._vars['video']){
	        this.__video = bVideo;

			// Create 'OK' button
			this._create('btn_video', 'obj_button', 'footer');
			this.btn_video._disabled(!bVideo);
			this.btn_video._value('DIAL::ANSWER_VIDEO');
		    this.btn_video._tabindex(5000);
			this.btn_video._onclick = function() {
				sip._answerCall(true);
			};
		}

		this.btn_ok._focus();
	}

	// Create 'CANCEL' button
	this._create('btn_cancel', 'obj_button', 'footer');
	this.btn_cancel._value('DIAL::DECLINE');
    this.btn_cancel._tabindex(5001);
	this.btn_cancel._onclick = function() {
		if (sip._getStatus() == 'Calling')
			sip._hangup();
		else
			sip._declineCall();
			
		me._destruct();
	};
};

_me._execute = function(aData){
	if (gui.frm_main.sip){
        var tmp = gui.frm_main.sip._getStatus();

		switch(tmp){
		case 'Call pending':
			//accept, decline
			if (this.btn_ok) this.btn_ok._disabled(false);
			if (this.btn_video && this.__video) this.btn_video._disabled(false);
			
			this.btn_cancel._value('DIAL::DECLINE');
		    break;

		case 'Calling':
			//disable, hangup
			if (this.btn_ok) this.btn_ok._disabled(true);
			if (this.btn_video && this.__video) this.btn_video._disabled(true);

			this.btn_cancel._value('DIAL::HANG_UP');

			dataSet.disobey(this.obj_label);
			
			if (!this.__timeInterval){
                this.__iterator = 1;
				this.__timeInterval = setInterval('try{'+this._pathName+'.__timer()}catch(e){}', 1000);
				this._add_destructor('__destruct');
			}

			break;
		    
		default:
			this._destruct();
		}
	}
};

_me.__destruct = function (){
	clearInterval(this.__timeInterval);
};

_me.__timer = function (){
	var h = Math.floor(this.__iterator/3600);
	var m = Math.floor((this.__iterator%3600)/60);
	var s = ((this.__iterator%3600)%60);

	this.obj_label._value(getLang('DIAL::CALL_DURATION',[(h?h+':':'')+(m<10?'0'+m:m)+':'+(s<10?'0'+s:s)]));

	this.__iterator++;
};