/*
   IceWarp Webmail v.6
   XML
*/


/************* cRequest ************  !! poresit sResponse vs bSync
 * @brief   Build HTTP Request Obj.
 * @author  DRZ 18.05.2005
 * @require:    XMLTools
 *
------------------------------
 pokusit se udelat this.oXMLHttp jako static

 * Properties:
 *    + sURL
 *    + bSync
 *    + bGET
 *
 *  Methods:
 *    + sendXML(xml[, replylistener])
 *    + sendArr(array[, replylistener])
 *    + sendStr(text[, replylistener])
 *    + this.oXMLHttp.responseText
 *    + this.oXMLHttp.responseXML
 *    + this.oXMLHttp.responseArr
 */
/*
  this.oXMLHttp.abort();

*/

function cHttpRequest(){
	this.sURL = 'server/webmail.php';	// Default request URL
	//this.bSync = false;				// false - async, true - sync
	//this.bGET = false;				// request type - GET|POST
	this.bIE = false;
	this.oXMLHttp = null;
	this.noLoader = false;

	// prepare request Obj.
	this.createDocument();
};

	cHttpRequest.prototype.createDocument = function() {
		if (window.XMLHttpRequest){
			this.oXMLHttp = new XMLHttpRequest();

			//MSIE 7
			this.bIE = currentBrowser().indexOf('MSIE')>-1;
		}
		else
		//MSIE 6
		if(!navigator.__ice_version && window.ActiveXObject){
			this.oXMLHttp = new ActiveXObject('Microsoft.XMLHTTP');
			this.bIE = true;
		}
		else
			throw new Error("cHTTPRequest() - Your browser does not support XMLHttpRequest objects");
	};



	/**
	 * @brief:	Send XML document thru HTTPRequest
	 * @param:	xData		- XML document
	 *			oResponse	- response object [object,method,[optional params,...]]
	 *          oResponse2	- response on error
	 *          bRetry      - private bool variable
	 * @date :	26.5.2006 16:37:19
	 **/

	cHttpRequest.prototype.sendXML = function(xData,oResponse,oResponse2,bRetry) {
		var oXMLHttp = this.oXMLHttp,
			bSync = typeof oResponse == 'object'?false:true,
			bGET = xData?false:true,
			skiperror = false,
			me = this;

		if (bRetry)
			this.__retry++;
		else{
			this.__retry = 0;

			if (!bSync && !bGET && !this.noLoader)
				gui._loading(true);
		}

		if ((currentBrowser()=='Mozilla' || currentBrowser()=='Safari') && !bSync && oXMLHttp.addEventListener){
			skiperror = true;
			try{
				var xD = xData,
					oR = oResponse,
					oR2 = oResponse2,
					bR = bRetry;

				oXMLHttp.addEventListener("error", function(e){
					try{
						var iStatus = e.target.status;
					}
					catch(r){
						return;
					}

					if (iStatus == 0 && !me.__failed){
						//Error response
						if (oR2 && !bR && !executeCallbackFunction(oR2)){
							if (!bGET && !me.noLoader)
								gui._loading();

							return;
						}
						else{
							if (gui.connection){
								gui.connection._add([me,'sendXML',[xD,oR,oR2,true]]);
							}
							else
							window.setTimeout(function(){
								me.sendXML(xD,oR,oR2,true);
							},15000);
						}
					}

				}, false);

				//Aborted
				oXMLHttp.addEventListener("abort", function(e){
					if (!bGET && !me.noLoader)
						gui._loading();

					var iStatus;
					try{
						iStatus = e.target.status;
					}
					catch(r){
						iStatus = 404;
					}

					// PAK ODENDAT CALLBACK S ERROREM
					if (Is.Array(oResponse)){
						executeCallbackFunction(oResponse,{"Array":{IQ:[{ATTRIBUTES:{TYPE:'error'},ERROR:[{ATTRIBUTES:{UID:'offline',STATUS:iStatus},VALUE:'Connection Lost'}]}]}});
						oResponse = null;
					}
				}, false);

				//oXMLHttp.addEventListener("onload", transferLoad, false);
            }
			//FFox 2
			catch(e){
                skiperror = false;
			}
		}

		//Open connection
		oXMLHttp.open((bGET?'GET':'POST'), this.sURL, !bSync);

        if (!bGET)
			oXMLHttp.setRequestHeader('Content-Type','text/xml');

		//Send data
		try{
			oXMLHttp.send(bGET?null:xData);
		}
		catch(e){}

		//sync mode
		if (bSync) {
            //clear memory
			xData = null;
			    //oXMLHttp.status &&
			if (oXMLHttp.status!=200 && oXMLHttp.status!=304){
                if (gui.connection)
                    gui.connection._add();
                    
				//throw "cHTTPRequest.send() - sync - URL "+ this.sURL +" returned: "+ oXMLHttp.statusText + " [" + oXMLHttp.status + "]";
				return false;
			}
			return true;
		}

		//async mode
		oXMLHttp.onreadystatechange = function () {
			try{
				if (oXMLHttp.readyState == 4) {
					// Error on server side
					if ((oXMLHttp.status!=200 && oXMLHttp.status!=304) || oXMLHttp.getResponseHeader("Content-Type") == null){

						//410 is WCS disconnect error
						if (oXMLHttp.status == '410')
							throw "cHTTPRequest.send() - async - URL "+me.sURL+" returned: "+ oXMLHttp.statusText + " [" + oXMLHttp.status + "]";
						else
						if (oXMLHttp.status == 0 && currentBrowser()!='Opera'){

							//do not handle errors for Mozilla and Safari browsers
							if (skiperror) return;

							throw 'abort';
						}
						else
						{
							//Error response
							if (oResponse2 && !bRetry && !executeCallbackFunction(oResponse2)){
                                if (!bGET && !this.noLoader)
									gui._loading();
									
								return;
							}

							if (gui.connection){
								if (oXMLHttp.status != 500 && me.__retry<3 && !gui.connection.__buffer.length)
									window.setTimeout(function(){
										me.sendXML(xData,oResponse,oResponse2,true);
									},5000);
								else{
									var sStatus = 'OFFLINE';
									try{
										if (oXMLHttp.statusText && oXMLHttp.statusText!='Unknown')
											sStatus = oXMLHttp.statusText;
									}
									catch(r){}
									gui.connection._add([me,'sendXML',[xData,oResponse,oResponse2,true]]);
								}
							}
							else
							window.setTimeout(function(){
								me.sendXML(xData,oResponse,oResponse2,true);
							},10000);
						}
					}
					else{
	                    //clear memory
						xData = null;

						var oRData = null;

						//Response
						if (Is.Array(oResponse)){

							try{
								switch(oResponse[3]){
								case 'XML':
									oRData = {"XML":me.responseXML()};
									break;
								case 'Text':
									oRData = {"Text":me.responseText()};
									break;
								default:
									oRData = {"Array":me.responseArray()};
								}
							}
							catch(err){
								if (typeof err == 'string')
							        throw err + ' ' + me.responseText();
							    else
									throw "Response parse error: \n"+me.responseText();
							}

							executeCallbackFunction(oResponse, oRData);
							oResponse = null;
						}
						else{
							try{
								oRData = {"Text":me.responseText(),"Array":me.responseArray()};
							}
							catch(err){
								throw "cHTTPRequest.send() - Can't convert Array:\n" + me.responseText();
							}

							// oResponse as object, create obj.responseData = dat and call obj.response() method
							try {
								oResponse.prototype.responseData = oRData;
								oResponse.response();
							}
							catch(err) {
								throw "cHTTPRequest.send() - URL "+this.sURL+" error in \n"+oResponse.toString();
							}
						}

						oRData = null;

						if (!bGET && !this.noLoader) gui._loading();
					
					}
				}
			}
			catch(e){

				try {
                	oXMLHttp.status;
				}
				catch(r){
				
					//Error response
					if (oResponse2 && !bRetry && !executeCallbackFunction(oResponse2)){
                        if (!bGET && !this.noLoader)
							gui._loading();

						return;
					}

					if (gui.connection){
						gui.connection._add([me,'sendXML',[xData,oResponse,oResponse2,true]]);
					}
					else
					window.setTimeout(function(){
						me.sendXML(xData,oResponse,oResponse2,true);
					},15000);

					return;
				}

				if (!bGET && !this.noLoader) gui._loading();
				
				// PAK ODENDAT CALLBACK S ERROREM
				if (Is.Array(oResponse)){
				
					//Neco se posralo
					if (oXMLHttp.status == 200)
						inspect2(e,true);

					executeCallbackFunction(oResponse,{"Array":{IQ:[{ATTRIBUTES:{TYPE:'error'},ERROR:[{ATTRIBUTES:{UID:'offline',STATUS:oXMLHttp.status},VALUE:'Connection Lost'}]}]}});
					oResponse = null;
				}

				//clear memory
				xData = null;
				if (oXMLHttp.status != 410 && typeof e == 'string' && e != 'abort'){
					throw e;
				}
			}
		};
	};
	
	
	
	
	
	
	
	
	
	
	
	
	

	/**
	 * @brief: strip WhiteSpaces from XML
	 */
	cHttpRequest.prototype.stripWhiteSpace = function (node) {
		this.nodesToDelete = Array();
		this.findWhiteSpace(node, 0);

		for(var i = this.nodesToDelete.length-1;i>=0;i--) {
			nodeRef = this.nodesToDelete[i];
			nodeRef.parentNode.removeChild(nodeRef);
		}

		this.nodesToDelete = null;
	};

		cHttpRequest.prototype.is_ws = function (nod) {
			return !(/[^\t\n\r ]/.test(nod.data));
		};

		cHttpRequest.prototype.findWhiteSpace = function (node, nodeNo) {
			for (var i=0; i<node.childNodes.length; i++) {
				if (node.childNodes[i].nodeType == 3 && this.is_ws(node.childNodes[i]))
					this.nodesToDelete[this.nodesToDelete.length] = node.childNodes[i];

				if (node.childNodes[i].hasChildNodes())
					this.findWhiteSpace(node.childNodes[i], i);
			}

			node = node.parentNode;
			i = nodeNo;
		};

	// PUBLIC
	cHttpRequest.prototype.sendArray = function(aData,oResponse,oResponse2,bPreserveCase){
		/* DEBUG */
		if (IWAPI_DEBUG)
			api_debug.add('send Array',aData);

		return this.sendXML(XMLTools.Arr2XML(aData,'',bPreserveCase),oResponse,oResponse2);
	};

	cHttpRequest.prototype.sendString = function(sData,oResponse){
		/* DEBUG */
		if (IWAPI_DEBUG)
			api_debug.add('send String',sData);

		//XMLTools.Str2XML(sData)
		this.sendXML(sData,oResponse);
	};

	cHttpRequest.prototype.responseText = function(){
		var s = this.oXMLHttp.responseText;

		/* DEBUG */
		if(IWAPI_DEBUG) api_debug.add('response String',s);

		return s;
	};

	cHttpRequest.prototype.responseXML = function(){

		try{
			var	xml = this.oXMLHttp.responseXML;
		}
		catch(e){
			throw "ERROR GET XML: " + this.responseText();
		}

		// Strip white space from response when browser isn't IE
		if (!this.bIE ) {
			/* commented because of XMPP
			var child = xml.childNodes[0];
			if (child && child.hasChildNodes && child.childNodes[0] && child.childNodes[0].nodeType == 3 && this.is_ws(child.childNodes[0]))
			*/
			this.stripWhiteSpace(xml);
		}

		return xml;
	};

	cHttpRequest.prototype.responseArray = function(){

		try{
			var a = {},
				sType = this.oXMLHttp.getResponseHeader("Content-Type");

			switch(sType){
			case 'text/json':
				if (window.JSON)
					a = window.JSON.parse(this.responseText());
				else
				if (currentBrowser() == 'Mozilla')
					a = new Function("return "+this.responseText())();
				else
					a = eval("(" + this.responseText() + ")");

				break;

			case 'text/xml':
			case 'application/xml':
				a = XMLTools.XML2Arr(this.responseXML());
			break;

			case null:
			case 'null':
				return {};
			default:
				throw 'unsupported content-type "' + sType +'"';
			}
		}
		catch(e){
			if (typeof e == 'string')

			throw "ERROR XML->ARRAY"+ (typeof e == 'string'?' ('+ e +')':'') +" : "+ this.responseText();

			return {};
		}

		/* DEBUG */
		if(IWAPI_DEBUG) api_debug.add('response Array',a);

		return a;
	};