/**
 * Horizontal menu object
 *
 * <p item>	is text content of menu
 *			if value is equal to '-' than <hr> tag is used instead of link
 *
 * Input array example:
 * x[<p item>]	[arg] = obj | string
 *				[disabled]
 *				[css] = 'className'
 *				[nodes][<ch item>]	[arg]
 *									[css]
 *									[nodes]
 **/
_me = obj_hmenu.prototype;
function obj_hmenu(){};

_me.__constructor = function(){

	this.__idtable = {};

	var me = this;

	this._main.onclick = function(e){
		var e = e || window.event;

		// ELEMENT which caused event
		var elm = e.target || e.srcElement;
		if (elm.tagName=='SPAN') elm = elm.parentNode;

		if (elm.tagName=='A'){
			// parse id
			var id = elm.id.substr(me._pathName.length+1);
	        if (me.__idtable[id] && !me.__idtable[id].disabled){
                var arg = me.__idtable[id].arg;

				if (me.__idtable[id].handler){
					if (me.__close) me.__close();
					executeCallbackFunction(me.__idtable[id].handler,me,elm,id,arg);
				}
				else
				if (arg) {
					if (me.__close) me.__close();
					me.__exeEvent('onclick',e,{"arg":arg,"id":id,"elm":elm,"owner":me});
					me._onclick(e,elm,id,arg);
				}
			}
		}
		else{
			e.cancelBubble = true;
			if (e.stopPropagation) e.stopPropagation();
		}

		return false;
	};

	this._main.oncontextmenu = function (e){
		return false;
	};
};

_me._fill = function (aData){

	/* retrieve data from dataset */
	this._clear();
	if (!aData) aData = dataSet.get(this._listener,this._listenerPath);
	if (!aData)	return;
	
	this.__aData = aData;

	this.__row(aData,'');
};

_me._clear = function (){
	/* clear the hmenu window */
	this._main.innerHTML = '';
};

_me.__row = function(aData,child){
	var elm1,elm2,elm3,me = this;

	/* create main UL element */
	elm1 = mkElement("ul");

	var path;
	if (!child) {
		/* prepare path */
		this.__idtable = {};
		path = '';
		/* set class for main UL element */
		elm1.className = this._main.className;
	}
	else
		path = child;

	var n = 0;

	for(var i in aData){
		elm2 = mkElement("li");

		if (aData[i]['nodes'] && !aData[i]['disabled']){
			elm2.onmouseover = function(e){

				var xBody = document.getElementsByTagName('body')[0].clientWidth,
                    yBody = document.getElementsByTagName('body')[0].clientHeight,
					elm = this.getElementsByTagName("UL")[0];
					elm.className = "open";

				var aPos = getSize(elm);

				//Y
				if (xBody<aPos.x+aPos.w)
					elm.style.marginLeft = '-95%';
					
				//X
				if (yBody<aPos.y+aPos.h)
					elm.style.bottom = '0px';

				elm = null;
				try{
					var elm = this.getElementsByTagName('A');
						elm = elm[elm.length-1];
					addcss(elm,'active');
					elm = null;
				}
				catch(r){}
			};

			elm2.onmouseout = function(e){

				var elm = this.getElementsByTagName("UL")[0];
				elm.className = "";
				elm = null;
				try{
					var elm = this.getElementsByTagName('A');
						elm = elm[elm.length-1];
					removecss(elm,'active');
					elm = null;
				}
				catch(ee){}
			};

			// parse and append child nodes
			elm2.appendChild(this.__row(aData[i]['nodes'],path + n + '/'));
		}

		elm3 = '';

		/* horizontal line */
		if (aData[i]['title'] == '-'){
            elm2.innerHTML += '<div'+(aData[i]['css']?' class="'+aData[i]['css']+'"':'')+'>&nbsp;</div>';
			addcss(elm2,'hr');
			delete aData[i]['nodes'];
		}
		else
		/* blank, create Anchor*/
		if (aData[i]['anchor']){
			this._anchors[aData[i]['anchor']] = this._pathName + '/' + path + aData[i]['anchor'];
			elm2.innerHTML += '<div'+(aData[i]['css']?' class="'+aData[i]['css']+'"':'')+' id="'+this._anchors[aData[i]['anchor']]+'">&nbsp;</div>';
			delete aData[i]['nodes'];
		}
		/* link */
		else{

			if (aData[i]['arg'])
				this.__idtable[path + n] = {arg:aData[i]['arg']};
				
			if (aData[i]['handler']){
				if (this.__idtable[path + n])
					this.__idtable[path + n].handler = aData[i]['handler'];
				else
					this.__idtable[path + n] = {"handler":aData[i]['handler']};
			}

			var css = 'menuitem';
			if (aData[i]['css'])
				css += ' '+aData[i]['css'];
			
			if (aData[i]['nodes']) {
				css += ' nodes';
				if (this.__idtable[path + n])
					this.__idtable[path + n].nodes = true;
				else
					this.__idtable[path + n] = {"nodes":true};
			}

			if (aData[i]['disabled'] || aData[i]['caption']){
                if (aData[i]['disabled'])
					css += ' disabled';
                if (aData[i]['caption'])
					css += ' caption';
					
				if (this.__idtable[path + n])
					this.__idtable[path + n].disabled = true;
				else
					this.__idtable[path + n] = {"disabled":true};
			}

			var inner_str = '';
			if (typeof aData[i]['title'] == 'string')
				inner_str = '<span>' + (aData[i]['title'].length?getLang(aData[i]['title']):'&nbsp;') + '</span>';
			else
			if (typeof aData[i]['text'] != 'undefined')
				inner_str = '<span>' + (aData[i]['text'].length?aData[i]['text']:'') +'</span>';
			else
				inner_str = '<span>' + i + '</span>';

			elm2.innerHTML += '<a href="javascript: void(0);" unselectable="on" class="'+css+'" id="'+(this._pathName + '/' + path + n)+'">'+inner_str+'</a>';
		}

		n++;
		elm1.appendChild(elm2);
	}

	/* set "end" className for last node with childs */
	if (elm2){
		addcss(elm2,'end');
		/* destruct html elements */
		elm2 = null;
		elm3 = null;
	}

	/* append root UL element into _main */
	if (!child) {
		this._main.appendChild(elm1);
		return;
	}

	/* return UL element */
	return elm1;
};


_me.__update = function(){
	this._fill();
};

/**
 * @brief: optional onclick method
 * @param: e    - Event Handler (onclick event object)
 *         elm  - srcElement (link)
 *         id   - objects internal id (without pathName)
 *         arg  - item's arg section
 *
 * _me._onclick = function(e,elm,id,arg){};
 */