/**
 * Horizontal menu object
 *
 * <p item>	is text content of menu
 *			if value is equal to '-' than <hr> tag is used instead of link
 *
 * Input array example:
 * x[<p item>]	[arg] = obj | string
 *				[disabled]
 *				[css] = 'className'
 *				[nodes][<ch item>]	[arg]
 *									[css]
 *									[nodes]
 **/
_me = obj_hmenu_plus.prototype;
function obj_hmenu_plus(){};

_me.__constructor = function(){
	var me = this;

	this.__ePull = null;
	this.__timeout = null;
	this.__openedNode = [];

	var busy = false;
	
	this._main.onmousemove = function(e){
		if (busy)
		    return;
		else
		    busy = true;

		var e = e || window.event,
			elm = e.target || e.srcElement;

        if (elm.tagName == 'SPAN')
			elm = elm.parentNode;
		if (elm.tagName != 'A'){
            busy = false;
			return false;
		}

		if (me.__timeout){
			window.clearTimeout(me.__timeout);
			me.__timeout = null;
		}

		var id = me.__getId(elm.id);
		if (me.__openedNode[me.__openedNode.length-1] == id){
            busy = false;
			return false;
		}
			

		//OPEN NEW NODES
		if (me.__aData[id] && typeof me.__aData[id].nodes == 'object'){

			//odznacit parent elm
			if (me.__openedNode.length)
                me.__close();

			//oznacit aktualni parent elm
			var prt = document.getElementById(me._pathName+'/'+id);
			if (prt){
 				addcss(prt,'active');
			    prt = null;
			}

			me.__openedNode.push(id);

			//vytvorit nabidku
			if (!me.__ePull){
				me.__ePull = mkElement('div');
				me.__ePull.className = 'obj_hmenu_plus'+(me._css?' '+me._css+'_plus':'');
				me.__ePull.onclick = me._main.onclick;

				me.__ePull.onmousemove = function(e){
					if (me.__timeout){
						window.clearTimeout(me.__timeout);
						me.__timeout = null;
					}
				};
				me.__ePull.onmouseout = function(e){
					if (!me.__timeout)
						me.__timeout = window.setTimeout(me._pathName+'.__close();',100);
				};

				document.body.appendChild(me.__ePull);
			}
			else{
            	me.__ePull.style.display = 'block';
            	me.__ePull.innerHTML = '';
			}

			//position
			var pos = getSize(elm);
			me.__ePull.style.left = pos.x;
			me.__ePull.style.top = pos.y+pos.h;

			//fill
			me.__ePull.appendChild(me.__row(me.__aData[id].nodes,id));
		}
		// try to close old nodes
		else
			me.__close();

		busy = false;
	};
	

	this._main.onmouseout = function(e){

		var e = e || window.event;
		var elm = e.target || e.srcElement;

		if (me.__openedNode!=null){

			if (me.__timeout)
				window.clearTimeout(me.__timeout);
				
			me.__timeout = window.setTimeout('try{'+me._pathName+'.__close();}catch(r){}',200);
		}

	};

	this._add_destructor('__close',[1]);
};

_me.__close = function(bFully){

	//clear timeout
	if (this.__timeout){
		window.clearTimeout(this.__timeout);
		this.__timeout = null;
	}

	//odznacit parenta
	if (this.__openedNode.length){
		for(var i = this.__openedNode.length-1;i>=0;i--){
			var elm = document.getElementById(this._pathName+'/'+this.__openedNode[i]);
			if (elm){
			    removecss(elm,'active');
				elm = null;
			}
			
			this.__openedNode.splice(i,1);
		}
	}

	//close popup
	try{
		if (this.__ePull)
			if (bFully){
				this.__ePull.parentNode.removeChild(this.__ePull);
				this.__ePull = null;
			}
			else
				this.__ePull.style.display = 'none';
	}
	catch(er){}
};















_me.__getId = function(elmid){
	return elmid.substr(this._pathName.length+1);
};

_me._fill = function (aData){

	this._clear();

	/* retrieve data from dataset */
	if (!aData && this._listener)
		this.__aData = dataSet.get(this._listener,this._listenerPath);
	else
		this.__aData = aData;

	if (!this.__aData) return;

	aData = clone(this.__aData,true);
	for(var i in aData){
		if (aData[i]['nodes']){
			delete aData[i]['nodes'];
			aData[i]['css'] = aData[i]['css']?aData[i]['css']+ ' nodes':'nodes';
		}
	}

	this.__row(aData);
};