_me = obj_tree_folder.prototype;
function obj_tree_folder(){};

/**
 * @date: 6.7.2006 16:28:30
 **/
 
_me.__constructor = function(sFilterAccountId, sFilterFolderType, sFilterRights, bSkipVirtual)
{
	var me = this;

	if (sFilterAccountId)
		this._filter_account(sFilterAccountId);

	if (sFilterFolderType)
		this._filter_folder(sFilterFolderType);

	if (sFilterRights)
		this._filter_rights(sFilterRights);

	if (bSkipVirtual)
		this._sFilterVirtual = true;

	/* Prepare data & create dataset if dosn't exist */
	var aAccounts = {};
	if (!(aAccounts = dataSet.get('accounts'))){
		aAccounts = accounts.list();
		dataSet.add('accounts',null,aAccounts);
	}
	
	if (!dataSet.get('folders')){
		var aFolders={};
		for (var sAccId in aAccounts)
			aFolders[sAccId] = folders.list({"aid":sAccId})[sAccId];

		dataSet.add('folders',null,aFolders);
	}

	this._listen_data('folders');

	//Drag and Drop
	this.__dndtimer = '';
	this._main.onmousedown = function(e){

		if (me.__dndtimer)
			window.clearTimeout(me.__dndtimer);

		var e = e || window.event;
		if (e.button>1 || e.ctrlKey || !me.__initdrag) return;
		var elm = e.target || e.srcElement;

		if (elm == this) return;
		if (elm.tagName != 'LI')
			elm = searchParent(elm,'LI');

		if (!elm || !elm.id) return;

		var tmp = (elm.id.substring(me._pathName.length+1)).split('/');

		//Account
		if (tmp.length<2) return true;	//Check type, (QL...)

		var id = [{aid:tmp.splice(0,1)[0],fid:tmp.join('/')}],
			sType = dataSet.get('folders',[id[0].aid,id[0].fid,'TYPE']),
			sDragType = 'folder';

		//Forbidden folders
		if (!sType || sType == 'A')
			return true;
		else
		if (id[0].aid == sPrimaryAccount && id[0].fid.indexOf('__@@VIRTUAL@@__/')==0)
			sDragType = 'virtual_folder';
			
		//fire the event :)
		var x = e.clientX, y = e.clientY;
		me.__dndtimer = setTimeout(function(){
			me.__initdrag(id,sType,x,y,sDragType);
		},500);
	};

	this._main.onmouseup = function(e){
        //stop DnD
		if (me.__dndtimer)
			clearTimeout(me.__dndtimer);
	};
	
	//Registr Drop
	if (gui.frm_main && gui.frm_main.dnd)
		gui.frm_main.dnd.registr_drop(this,['item','folder']);
};

_me._filter_account = function (sFilterAccountId){
	this.sFilterAccountId = sFilterAccountId;
};
_me._filter_folder = function (sFilterFolderType){
	this._sFilterFolderType = {};

	if (typeof sFilterFolderType == 'object')
	    for(var i in sFilterFolderType)
	    	this._sFilterFolderType[sFilterFolderType[i]] = true;
    else
    if (sFilterFolderType)
    	this._sFilterFolderType[sFilterFolderType] = true;
};

_me._filter_rights = function (sFilterRights){
	this._sFilterRights = [];

	if (sFilterRights)
		this._sFilterRights = sFilterRights.split('');
};

/**
 * Drag & Drop
 **/
_me.__initdrag = function(id,sType,x,y,sDragType){

	//disable drag if rename state
	if (this.rename) return false;

	//prepare data
	var aName = id[0].fid.split('/'),
		sBody = '<div class="drag_folder drag_folder_'+sType+'">'+ aName[aName.length-1] +'</div>';

	//create Drag box
	gui.frm_main.dnd.create_drag(sBody, {type:sDragType || 'folder',value:id}, x, y);
};

_me._active_dropzone = function(v){

	this.__aDragFolders = [];
	
	if(v){
		var val = {} ,tmp = this._value();
		for (var i in tmp)
		    val[tmp[i]] = 1;

		switch(v['type']){
		case 'item':
			var itmtype = dataSet.get('folders',[v.value[0].aid,v.value[0].fid,'TYPE']);


			var getTargets = function (data,out){
				if (!out) out = [];
				if (typeof data != 'object') return out;

				var i, sPath;
				for(i in data){
					sPath = data[i].arg.aid+(data[i].arg.fid?'/'+data[i].arg.fid:'');

					if (data[i].arg){
						if ((itmtype == 'M' || itmtype == 'P') && data[i].arg.ftype == 'QL' && (data[i].arg.aid != v.value[0].aid || data[i].arg.fid != v.value[0].fid))
							out.push(sPath);
						else
	 					if ((itmtype == 'M' || itmtype == 'P' || data[i].arg.ftype != 'M') && WMFolders.getAccess({aid:data[i].arg.aid,fid:data[i].arg.fid},'write') && (data[i].arg.fid != v.value[0].fid || data[i].arg.aid != v.value[0].aid))
							out.push(sPath);
					}

					if (data[i].nodes && val[sPath])
						getTargets(data[i].nodes,out);
				}
				return out;
			};

			this.__aDragFolders = getTargets(this.__aFillData);

			addcss(this._main,'active_drop');
			break;
			
		case 'folder':

			if (!this.__aFillData[v.value[0].aid] || !this.__aFillData[v.value[0].aid].nodes ||	!WMFolders.getRights(v.value[0],'remove') || dataSet.get('folders',[v.value[0].aid,v.value[0].fid,'TYPE']) == 'QL')
				break;

			var getTargets2 = function (data,out){
                if (!out) out = [];
                if (typeof data != 'object') return out;

                var i, sPath;
				for(i in data){
                	sPath = data[i].arg.aid+'/'+data[i].arg.fid;

					if (data[i].arg.ftype != 'QL' && data[i].arg.ftype != 'X'){

						if (v.value[0].aid+'/'+v.value[0].fid != sPath && WMFolders.getAccess({aid:v.value[0].aid,fid:data[i].arg.fid},'write'))
							out.push(sPath);

						if (data[i].nodes && val[sPath])
							getTargets2(data[i].nodes,out);
					}
				}
                return out;
			};

			this.__aDragFolders = getTargets2(this.__aFillData[v.value[0].aid].nodes);
            this.__aDragFolders.push(v.value[0].aid);
            
            addcss(this._main,'active_drop');
		}
	}
	else{
		removecss(this._main,'active_drop');
		this._ondragout();
	}
};

_me._ondragover = function(v){

	var a,size,elm,bOk = false;

	if (this.__aDragFolders)
		for (var i=0;i<this.__aDragFolders.length;i++){
			if (!(elm = document.getElementById(this._pathName+'/'+this.__aDragFolders[i])))
	      		continue;

			size = getSize(elm);

			if (v.y>=size.y && v.y<=size.y+20){

				a = elm.getElementsByTagName('B')[0];
				if (this.___lastdragover != a){
		            if (this.___lastdragover)
						removecss(this.___lastdragover,'dragover');

					this.___lastdragover = a;
			        addcss(a,'dragover');
		        }

				bOk = true;
				break;
			}
			else
			if (this.___lastdragover){
	            removecss(this.___lastdragover,'dragover');
	            this.___lastdragover = '';
	        }
		}

	a = null;
	elm = null;
	
	return bOk;
};

_me._ondragout = function(v){
	if (this.___lastdragover)
		removecss(this.___lastdragover,'dragover');

	this.___lastdragover = null;
};

_me._ondrop = function(v){

	var size,elm,id = '';
/*
	if (currentBrowser() != 'Mozilla') // FF3 only?
		v.y += this._main.scrollTop;
*/
	for (var i=0;i<this.__aDragFolders.length;i++){
		if (!(elm = document.getElementById(this._pathName+'/'+this.__aDragFolders[i])))
			continue;

		size = getSize(elm);

		if (v.y>=size.y && v.y<=size.y+20){
			id = this.__aDragFolders[i];
			break;
		}
	}
	if (!id) return false;


	var pos = id.indexOf('/'),
		fol = '',
		acc = id;

	if (pos>-1){
		fol = id.substr(pos+1);
		acc = id.substr(0,pos);
	}


	switch(v.type){
	case 'folder':

		this._invalidateActive();

		//Drag & Drop doesnt work with popups because of event handlers.
		gui.frm_main.dnd.remove_drag(true);

		var sNewFolder = (fol?fol + '/':'') + Path.basename(v.value[0].fid);
		WMFolders.add({'aid':v.value[0].aid,'fid':v.value[0].fid,'name':sNewFolder},'folders');

		break;

	case 'item':
		if (!fol) return;

		var t1  = dataSet.get('folders',[acc,fol,'TYPE']);
		var t2  = dataSet.get('folders',[v.value[0].aid,v.value[0].fid,'TYPE']);
		var ids = [v.value[0].aid,v.value[0].fid,[]];
		for(var i in v.value)
			ids[2].push(v.value[i].iid);


		//Drag & Drop doesnt work with popups because of event handlers.
		gui.frm_main.dnd.remove_drag(true);

		if (fol == 'SPAM_QUEUE/Whitelist' || fol == 'SPAM_QUEUE/Blacklist')
			OldMessage.__blackOrWhiteList(ids, fol == 'SPAM_QUEUE/Whitelist');
		else
		if (t1!=t2){

			// DODELAT VALUES s ATT
			var title = [], name, mail, q, note, tmp, arg, out, att = [];
			for(var i in v.value){


				arg = {	id:v.value[i].iid,
						fullpath:v.value[i].aid+'/'+v.value[i].fid+'/'+v.value[i].iid,
						embedded:true};

				switch(t2){
				case 'P':
				case 'M':
					arg.title = dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'SUBJECT']);
					arg.size =  dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'SIZE']);

					if (!title[0]){
						if (t1=='C'){
							var splited = MailAddress.splitEmailsAndNames(dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'FROM']));
							if (splited[0]){
								mail = splited[0].email;
								name = splited[0].name;
							}
						}
						title.push(arg.title);

						q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['TEXT']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid])
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].TEXT;
					}

					if (t1!='F') arg.title += '.eml';

					break;
				case 'F':

					arg.size = dataSet.get('items',[v.value[i].aid,v.value[i].fid, v.value[i].iid,'EVNCOMPLETE']) || 0;

					var aData = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['EVN_ID']});
					if (aData){
						aData = aData[v.value[i].aid][v.value[i].fid][v.value[i].iid];
						for (var sAtId in aData['ATTACHMENTS'])
							break;

						arg.fullpath += '/'+sAtId; //dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'EVNTITLE']);
						arg.type = 'push_attachment';

						if (typeof title[0] == 'undefined' && !note)
							note = aData.EVNNOTE;
					}

					break;
				case 'C':
				case 'D':

					if (typeof title[0] == 'undefined' && !note){
						q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['ITMDESCRIPTION']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid])
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].ITMDESCRIPTION;
					}

					if (t1!='F') arg.title = '.vcf';
					break;

				case 'N':

					if (typeof title[0] == 'undefined' && !note){
						q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['NOTES']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid].NOTES)
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].NOTES[0].values.NOTE_TEXT;
					}

				case 'T':
				case 'E':
				case 'J':

					if (typeof title[0] == 'undefined' && !note){
						q = WMItems.list({"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid, "values": ['EVNNOTE']});
						if (q[v.value[i].aid] && q[v.value[i].aid][v.value[i].fid] && q[v.value[i].aid][v.value[i].fid][v.value[i].iid])
							note = q[v.value[i].aid][v.value[i].fid][v.value[i].iid].EVNNOTE;
					}

					if (t1!='F') arg.title = '.vcs';
				}

				if (t2!='M' && t2!='P'){
					tmp = dataSet.get('items',[v.value[i].aid,v.value[i].fid,v.value[i].iid,'EVNTITLE']);
					title.push(tmp);
					arg.title = tmp + (arg.title || '');
				}

				att.push(arg);
			}

			out = {};

			if (name){
				var sTmp,aName = name.split(' ');
				if (aName.length>1){
					//FirstName
					sTmp = aName.shift();
					if (sTmp.indexOf('.')>0){
						sTmp = sTmp.split('.');
						out.ITMTITLE = sTmp[0];
						out.ITMFIRSTNAME = sTmp[1];
					}
					else
						out.ITMSURNAME = sTmp;

					//MiddleName
					sTmp = aName.shift();
					if (out.length>2 && out[2].indexOf('.')!=0){
						out.ITMMIDDLENAME = sTmp;
						sTmp = aName.shift();
					}

					//SurName
					if (sTmp.indexOf('.')>-1){
						sTmp = sTmp.split('.');
						out.ITMSURNAME = sTmp.shift();
						out.ITMSUFFIX = sTmp.join('.');
					}
					else{
						out.ITMFIRSTNAME = sTmp;

						//Suffix 2
						if ((sTmp = aName.shift()))
							out.ITMSUFFIX = sTmp;
					}
				}

				out.ITMCLASSIFYAS = name;
			}

			if (mail)
				out.LOCATIONS = [{values:{LCTTYPE:'H',LCTEMAIL1:mail}}];

			if (note){
				switch(t1){
				case 'C':
				case 'D':
				    out.ITMDESCRIPTION = note;
					break;
				case 'N':
					out.NOTES = [{values:{NOTE_TEXT:note}}];
					break;
				default:
					out.EVNNOTE = note;
				}
			}

			out.EVNTITLE = title.join(', ');
			out.PUSH_ATTACHMENTS = att;

			Item.createInFolder(acc, fol, out);
		}
		else
			Item.__copyOrMoveItems(acc, fol, v.ctrl?'copy':'move', ids);
	}
};

_me.__prepare_data = function(aData)
{
	var aResult = {}

	var aFrame,aSplitFolder,aParcSplitFolder,sFolder,sFolderType,bCanDelete,bCanRename,
		sTotal,bRecent,sIconClass,sMainClass,bDisabled,aAccounts = {},aAccounts_tmp = dataSet.get('accounts');

	//SORT
	var srt = [];
	for(var i in aAccounts_tmp)
		if (i!=sPrimaryAccount)
			srt.push(i);

	srt = srt.sort();
	aAccounts[sPrimaryAccount] = aAccounts_tmp[sPrimaryAccount];
	for(var i = 0;i<srt.length;i++)
		aAccounts[srt[i]] = aAccounts_tmp[srt[i]];
	aAccounts_tmp = null;

	//get common folders
	storage.library('wm_folders');
	var sSpamPath = dataSet.get('main',['spam_path']),
		sArchivePath = dataSet.get('main',['archive_path']),
		aDFolders = GWOthers.get('DEFAULT_FOLDERS','storage')['VALUES'];

	//Procházíme jednotlivé accounts
	for(var sAccId in aAccounts)
	{
		//ACCOUNT filter
		if (this.sFilterAccountId && sAccId != this.sFilterAccountId)
			continue;

		if (aAccounts[sAccId]['DESCRIPTION']){
			aResult[sAccId] = {"nodes":{},"arg":{"aid":sAccId},"text":aAccounts[sAccId]['DESCRIPTION']};
			if (sAccId == sPrimaryAccount+'_rss')
				aResult[sAccId].liclass = 'rss';
		}
		else
			aResult[sAccId] = {"nodes":{},"arg":{"aid":sAccId}};



		//Procházíme jednotlivé folders
		for(var sFolId in aData[sAccId])
		{

			//VIRTUAL filter
			if (this._sFilterVirtual && sAccId == sPrimaryAccount && sFolId.indexOf('__@@VIRTUAL@@__/') == 0)
				continue;

			//TYPE filter
			if (this._sFilterFolderType)
				if (!this._sFilterFolderType[aData[sAccId][sFolId]['TYPE']])
					continue;

			//RIGHTS filter (regExp.test() doesnt work properly in loop)
			if (this._sFilterRights){
				var bSkip = false,
					sRights = Cookie.get(['rights',sAccId,sFolId]).join('');

				for (var r in this._sFilterRights)
					if (sRights.indexOf(this._sFilterRights[r])<0){
						bSkip = true;
						break;
					}

				if (bSkip)
					continue;
			}

			aSplitFolder = sFolId.split("/");
			aParcSplitFolder = [];
			aFrame = aResult[sAccId]["nodes"];

			//Procházíme cestu folderu
			for(var i in aSplitFolder)
			{
				aParcSplitFolder.push(aSplitFolder[i]);
				sFolder = aParcSplitFolder.join('/');

				//Nemáme uzel ještě nastavený
				if (!aFrame[aSplitFolder[i]]){

					//Máme uzel definovaný ve vstupních datech
					if (aData[sAccId][sFolder] && (sFolderType = aData[sAccId][sFolder]['TYPE'])){

						bDisabled = (sFolder != sFolId);

						bRecent = aData[sAccId][sFolder]['RECENT']>0 ? true : false;
						sTotal =  bRecent ? '('+aData[sAccId][sFolder]['RECENT']+')' : '';
						sMainClass = bRecent ? 'recent' : '';

						switch (sAccId + '/' + sFolId){
							case (sAccId+'/INBOX') : sIconClass = 'ico_inbox'; break;
							case aDFolders.trash: sIconClass = 'ico_trash'; break;
							case aDFolders.sent: sIconClass = 'ico_sent'; break;
							case aDFolders.drafts: sIconClass = 'ico_drafts'; break;

							case sSpamPath: sIconClass = 'ico_spam'; break;
							case sArchivePath: sIconClass = 'ico_archive'; break;

							case (sAccId+'/Quarantine') : sIconClass = 'ico_quarantine'; break;
							case (sAccId+'/SPAM_QUEUE/Blacklist') :	sIconClass = 'ico_black'; break;
							case (sAccId+'/SPAM_QUEUE/Whitelist') : sIconClass = 'ico_white'; break;
							default:
								if ((sFolderType=='M' || sFolderType=='X') && sFolId.indexOf('~')==0 && sFolId.indexOf('@')>0 && sFolId.indexOf('/')<0)
									sIconClass = 'ico_a';
								else
								if (aData[sAccId][sFolder].PUBLIC)
									sIconClass = 'ico_shared';
								else{
									sIconClass = (sFolderType ? 'ico_' + sFolderType : '').toLowerCase();

									switch(sAccId + '/' + sFolId){
										case aDFolders.contacts:
										case aDFolders.events:
										case aDFolders.notes:
										case aDFolders.journal:
										case aDFolders.files:
											sMainClass+=' default';
									}
								}
						}

						aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":sFolderType,"disabled":bDisabled},"title2":'&nbsp;'+sTotal,"ico":sIconClass,"itmclass":sMainClass};
						if (aData[sAccId][sFolder]['NAME'])
							aFrame[aSplitFolder[i]]['text'] = aData[sAccId][sFolder]['NAME'];
					}
					else
					if (sFolder == 'SPAM_QUEUE')
						aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":"X","disabled":"true"},"title":'COMMON_FOLDERS::SPAM_QUEUE',"title2":' ',"itmclass":sMainClass,"ico":'ico_spamqueue'};
					else
					if (sFolder == '__@@VIRTUAL@@__')
						aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":"X","disabled":"true"},"title":'COMMON_FOLDERS::VIRTUAL-FOLDERS',"title2":' ',"itmclass":sMainClass,"ico":'ico_virtual'};
					else
						aFrame[aSplitFolder[i]] = {"nodes":{},"arg":{"aid":sAccId,"fid":sFolder,"ftype":"X","disabled":"true"},"title2":' ',"itmclass":sMainClass,"ico":'ico_shared'};
				}
				else
				// folder has been marked as disabled, because it was added as a parent of another folder
				// now - when this folder should really be added, disabled flag should be removed
				if (sFolder == sFolId && aData[sAccId][sFolder])
					aFrame[aSplitFolder[i]]["arg"]["disabled"] = false;

				aFrame = aFrame[aSplitFolder[i]]["nodes"];
			}
		}

		if (this._sFilterFolderType && Is.Empty(aResult[sAccId]['nodes']) && sAccId != sPrimaryAccount) delete aResult[sAccId];
	}

	return aResult;
};

/**
 * @brief: redraw tree object
 **/
_me._fill = function (aData){

	// retrieve data from dataset
	if (!aData) aData = dataSet.get(this._listener_data,this._listenerPath_data);
	if (!aData){
		// clear container object
		this._main.innerHTML = '';
		return;
	}
	
	//important for Drag & Drop
	this.__aFillData = this.__prepare_data(aData);

	this.__row(this.__aFillData);
};