function wm_accounts(){
	this.xmlns='accounts';
};

wm_accounts.inherit(wm_generic);
var _me = wm_accounts.prototype;

//********************************************************************************
//Základní SET funkce pro pro přidávání a update accountu
//********************************************************************************
//Vstup: aAccountInfo ... asociativní pole klíčů:
//  povinné:
//  nepovinné:
//********************************************************************************

_me.add = function(aAccountInfo,sDataSet,aDataPath,aHandler){
	var aRequest,uid;

	//EDIT
	if (aAccountInfo['aid']){
		aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"ACTION":"edit","UID":aAccountInfo['aid']}}]};
		var aFrame = aRequest["ACCOUNT"][0];

		for(var sTag in aAccountInfo)
			if (sTag == 'acl'){
			
				//<right email="{group_email}">{rights}</right>

				var aGrp = [];
				for (var i in aAccountInfo['acl'])
					aGrp.push({VALUE:aAccountInfo['acl'][i].join(''),ATTRIBUTES:{EMAIL:i}});

				if (aGrp.length)
					aFrame.ACL = [{RIGHT:aGrp}];
				else
				    aFrame.ACL = [{VALUE:''}];
			}
			else
			if (sTag != 'aid')
				aFrame[sTag]=[{"VALUE":aAccountInfo[sTag]}];
				
		uid = aAccountInfo['aid'];
	}
	else
	//ADD
	if (aAccountInfo['SERVER'] && aAccountInfo['USERNAME'] && aAccountInfo['PASSWORD'] && aAccountInfo['EMAIL']){
		switch(aAccountInfo['PROTOCOL']){
			case 'imap':
			case 'pop3':
			case 'local': break;
			default: aAccountInfo['PROTOCOL'] = 'pop3';
		}

		if (!aAccountInfo['PORT'])
			if (aAccountInfo['PROTOCOL']=='imap')
				aAccountInfo['PORT'] = 143;
			else
				aAccountInfo['PORT'] = 110;

		uid = aAccountInfo['EMAIL'];

		aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"ACTION":"add"},
					"PROTOCOL":[{"VALUE":aAccountInfo['PROTOCOL']}],
					"SERVER":[{"VALUE":aAccountInfo['SERVER']}],
					"USERNAME":[{"VALUE":aAccountInfo['USERNAME']}],
					"PASSWORD":[{"VALUE":aAccountInfo['PASSWORD']}],
					"PORT":[{"VALUE":aAccountInfo['PORT']}],
					"EMAIL":[{"VALUE":aAccountInfo['EMAIL']}],
					"DESCRIPTION":[{"VALUE":aAccountInfo['DESCRIPTION']}]}]};
	}
	else
		return false;

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		var aResponse = this.create_iq(aRequest,'','','set');
		try{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE']=='result')
				return true;
		}
		catch(e){}
		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['add',sDataSet,aDataPath,aHandler]],'','set', uid);
		return true;
	}
};

/*
<iq sid="{sid}" type="set">
<query xmlns="webmail:iq:accounts">
<account uid="{owner_account}" action="subscribe|unsubscribe">
<subscribtion>{subscribtion_account}</subscription>
<subscribtion>{subscribtion_account2}</subscription>
</account>
</query>
</iq>
*/
_me.subscribe = function(aAccountInfo,aHandler){
	if (!aAccountInfo || !aAccountInfo.subscription || !aAccountInfo.subscription.length)
		return;

	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"ACTION":'subscribe',"UID":sPrimaryAccount}}]};

	var aSub = [];
	for (var i in aAccountInfo.subscription)
		aSub.push({VALUE:aAccountInfo.subscription[i]});

	aRequest.ACCOUNT[0].SUBSCRIPTION = aSub;

	//AJAX...
	this.create_iq(aRequest,[this,'response',['subscribe','','',aHandler]],'','set');
	return true;
};

/*

<--
<iq sid="b48b0e0736f0b1104b91708c69c61157" type="set">
<query xmlns="webmail:iq:accounts">
<account action="test">
<email>{email}</email>
<username>{username}</username>
<password>{password}</password>
<server>{server}</server>
<port>{port}</port>
<protocol>{protocol}</protocol>
</account>
</query>
</iq>

->
<?xml version="1.0" encoding="utf-8" ?>
<iq sid="b48b0e0736f0b1104b91708c69c61157" type="result">
<result>true|false</result>
</iq>

*/
_me.test = function(aAccountInfo,aHandler){

	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"ACTION":"test"}}]};
	var aAccount = aRequest.ACCOUNT[0];
		aAccount.EMAIL = [{VALUE:aAccountInfo.EMAIL}];
		aAccount.USERNAME = [{VALUE:aAccountInfo.USERNAME}];

		if (aAccountInfo.PASSWORD)
			aAccount.PASSWORD = [{VALUE:aAccountInfo.PASSWORD}];

		aAccount.SERVER = [{VALUE:aAccountInfo.SERVER}];
		aAccount.PORT = [{VALUE:aAccountInfo.PORT}];
		aAccount.PROTOCOL = [{VALUE:aAccountInfo.PROTOCOL}];


	if (!aHandler){
		var aResponse = this.create_iq(aRequest,'','','set');
		try{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE']=='result')
				return true;
		}
		catch(e){}
		return false;
	}
	else{
		//AJAX...
		this.create_iq('',[this,'response',['test',sDataSet,aDataPath,aHandler]],'','set');
		return true;
	}
};

/*
Self sign up

<iq type="set">
<query xmlns="webmail:iq:accounts">
<account action="signup">
<username>testik</username>
<password>testik</password>
[<fullname>]
[<alternative>]
<email>testik@icewarpdemo.com</email>
<captcha uid="{captchaUID}">TRLH BH78</captcha>
</account>
</query>
</iq>
*/
_me._signup = function(sUser,sPass,sFull,sDomain,sAlt,csid,captcha){

	aRequest = {"ACCOUNT":[{
	ATTRIBUTES:{ACTION:'signup'},
	USERNAME:[{VALUE:sUser}],
	PASSWORD:[{VALUE:sPass}],
	FULLNAME:[{VALUE:sFull}],
	ALTERNATIVE:[{VALUE:sAlt}],
	EMAIL:[{VALUE:sUser+'@'+sDomain}],
	CAPTCHA:[{ATTRIBUTES:{UID:csid},VALUE:captcha}]
	}]};

	var aResponse = (this.create_iq(aRequest,'','','set')).IQ[0];

	if (aResponse.ATTRIBUTES.TYPE == 'result')
		return {'uid':true};
	else
	if (aResponse.ATTRIBUTES.TYPE == 'error')
		return {'uid':aResponse.ERROR[0].ATTRIBUTES.UID,'value':aResponse.ERROR[0].VALUE};
	else
		return false;
};

//********************************************************************************
//Základní GET funkce pro listování accountů
//********************************************************************************

_me.license = function(aHandler){
    var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"ACTION":'license',"UID":sPrimaryAccount}}]};
	this.create_iq(aRequest,[this,'response',['license',null,null,aHandler]],'','get');
	return true;
};

_me.list = function(aAccountInfo,sDataSet,aDataPath,sParam,aHandler){
	var aRequest = '';

	if (aAccountInfo && aAccountInfo.aid)
		aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aAccountInfo['aid']}}]};

	//Pracujeme synchronně či asynchronně?
	if (sDataSet || aHandler){
		//AJAX...
		this.create_iq(aRequest,[this,'response',['list',sDataSet,aDataPath,aHandler]],'','get',sParam);
		return true;
	}
	else
		return this.account_sort(this.parse(this.create_iq(aRequest)));
};
	// sort accounts (main on top and rss on bottom)
	_me.account_sort = function(arr){
		var main={},rss={};
		for(var i in arr){
			if (arr[i].PRIMARY){
				main[i] = arr[i];
				delete arr[i];
			}
			else
			if (arr[i].TYPE == 'rss'){
				rss[i] = arr[i];
				delete arr[i];
			}
		}
		for (i in arr)
			main[i] = arr[i];
		for (i in rss)
			main[i] = rss[i];

		return main;
	}

_me.refresh = function(aAccountInfo,sDataSet,aDataPath,aHandler){

	//Máme definované account_id?
	if (!aAccountInfo['aid']) return false;

	//Vytvoříme XML dotaz pro refresh accountů
	// <ACCOUNT UID='aid' ACTION='refresh'/>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"ACTION":"refresh","UID":aAccountInfo['aid']}}]};

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		//var folders = new wm_folders;
		//var result = WMFolders.sort(WMFolders.parse(this.create_iq(aRequest,'','set')));
		
		var result = WMFolders.parse(this.create_iq(aRequest,'','','set'));

		//map folders
		if (result[sPrimaryAccount])
			this.__mapfolders(result[sPrimaryAccount]);

		return result;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['refresh',sDataSet,aDataPath,aHandler]],'','set',aAccountInfo['aid'],'',true);
		return true;
	}
};

//********************************************************************************
//Základní SET funkce pro pro mazání accountu
//********************************************************************************
//Vstup: aAccountInfo ... asociativní pole klíčů:
//  povinné:   'aid':account_id
//********************************************************************************

_me.remove = function(aAccountInfo,sDataSet,aDataPath,sParam){
	//Máme definované account_id?
	if (!aAccountInfo['aid'])
		return false;

	//Vytvoříme XML dotaz pro synchronizaci accountů
	// <ACCOUNT UID='aid' ACTION='delete'/>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"ACTION":"delete","UID":aAccountInfo['aid']}}]};

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		var aResponse = this.create_iq(aRequest,'','','set');
		try{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE']=='result')
			return true;
		}
		catch(e){}
		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['remove',sDataSet,aDataPath]],'','set',sParam);
		return true;
	}
};

//********************************************************************************
//Základní SET funkce pro vyvolání synchronizace accountů na serveru
//********************************************************************************

_me.synchronize = function(aFoldersInfo,sDataSet,aDataPath){
	//Máme definované account_id?
	if (!aFoldersInfo['aid'])
		return false;

	//Vytvoříme strukturu XML dotazu pro synchronizaci folderu v accountu
	// <ACCOUNT UID='aid'><FOLDER ACTION="sync"/></ACCOUNT>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aFoldersInfo['aid']},"FOLDER":[{"ATTRIBUTES":{"ACTION":"sync"}}]}]};

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		var aResponse = this.create_iq(aRequest,'','','set');
		try{
			if (aResponse['Array']['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result')
			return true;
		}
		catch(e) {}

		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['synchronize',sDataSet,aDataPath]],'','set');
		return true;
	}
};

//********************************************************************************
//Základní SET funkce pro vyvolání synchronizace accountů na serveru
// následovaná GET funkcí listující accounty
//********************************************************************************

_me.synclist = function(aFoldersInfo,sDataSet,aDataPath){
	//Máme definované account_id?
	if (!aFoldersInfo['aid']) return false;

	//Vytvoříme strukturu XML dotazu pro synchronizaci folderu v accountu
	// <ACCOUNT UID='aid'><FOLDER ACTION="sync"/></ACCOUNT>
	var aRequest = {"ACCOUNT":[{"ATTRIBUTES":{"UID":aFoldersInfo['aid'],"ACTION":"sync"}}]};

	//Pracujeme synchronně či asynchronně?
	if (!sDataSet){
		var aResponse = this.create_iq(aRequest,'','','set');
		try{
			//Proběhla-li synchronizace úspěšně, budeme foldery v accountu listovat
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE'] == 'result'){
				var folders = new wm_folders;
				return folders.list({'aid':aFoldersInfo['aid']});
			}
		}
		catch(e) {}

		return false;
	}
	else{
		//AJAX...
		this.create_iq(aRequest,[this,'response',['synclist',sDataSet,aDataPath]],'','set',aFoldersInfo['aid']);
		return true;
	}
};

//********************************************************************************
//Pomocná funkce realizující asynchronní obsluhu odpovědi
//********************************************************************************

_me.response = function(aResponse,sMethodName,sDataSet,aDataPath,aHandler){
	var aXMLResponse = aResponse['Array'];
	var aIQAttribute = aXMLResponse['IQ'][0]['ATTRIBUTES'];

	switch(sMethodName){
	case 'license':
		if (aHandler)
			executeCallbackFunction(aHandler,aXMLResponse);
			
		break;
		
	case 'subscribe':
		if (aIQAttribute['TYPE'] == 'result')
			this.refresh({'aid':sPrimaryAccount},'folders');

		if (aHandler)
			executeCallbackFunction(aHandler,aXMLResponse);
		
		break;

	case 'test':

		var out = false;
		try{
			if (aResponse['IQ'][0]['ATTRIBUTES']['TYPE']=='result')
				out = true;
		}
		catch(e){}
		executeCallbackFunction(aHandler,out);
		return;

	case 'list':
		if (aIQAttribute['TYPE'] == 'result'){
			if (sDataSet)
				dataSet.add(sDataSet,aDataPath,this.account_sort(this.parse(aXMLResponse)));
				
			if (aHandler)
				executeCallbackFunction(aHandler,this.account_sort(this.parse(aXMLResponse)));

			if (aIQAttribute['UID']){
				var aAccounts = dataSet.get(sDataSet,aDataPath);
				dataSet.remove(aIQAttribute['UID'],'',true);
				for(sAccId in aAccounts)
					WMFolders.list({'aid':sAccId},aIQAttribute['UID']);
			}
		}
		return true;

	case 'refresh':
		if (aIQAttribute['TYPE'] == 'error') {
			var str, att;
			try{
				att = aXMLResponse.IQ[0].ERROR[0].ATTRIBUTES.UID;
				str = aXMLResponse.IQ[0].ERROR[0].VALUE;
			}
			catch(e){
				str = att = '';
			}
				
			if (att.toLowerCase() == 'imap_internal'){
				if (typeof aHandler == 'object')
					executeCallbackFunction(aHandler,(aIQAttribute['UID']?aIQAttribute['UID'] + "\n":'')+str.unescapeHTML());
				else
					alert((aIQAttribute['UID']?aIQAttribute['UID'] + "\n":'')+str.unescapeHTML());
			}
		}
		
	case 'synchronize':
		if (aIQAttribute['TYPE'] == 'result' && aIQAttribute['UID']){

			var aParsedData = WMFolders.parse(aXMLResponse);

			//map folders
			if (sPrimaryAccount == aIQAttribute['UID']){

				var	iRecent_old = null;
				if (dataSet.get(sDataSet,[aIQAttribute['UID'],'INBOX']))
					iRecent_old = dataSet.get(sDataSet,[aIQAttribute['UID'],'INBOX','RECENT']) || 0;

				this.__mapfolders(aParsedData[aIQAttribute['UID']]);
				dataSet.add(sDataSet, [aIQAttribute['UID']], aParsedData[aIQAttribute['UID']]);

				if (iRecent_old !== null && parseInt(iRecent_old) < dataSet.get(sDataSet,[aIQAttribute['UID'],'INBOX','RECENT'])){

					//change title
					if (gui.frm_main && gui.frm_main.title)
						gui.frm_main.title._add(getLang('TITLE::NEW_EMAIL'),10);

					//new email sound
					storage.library('gw_others');
					if (gui.frm_main && gui.frm_main.sound && parseInt(GWOthers.getItem('MAIL_SETTINGS_GENERAL','sound_notify'))>0)
						gui.frm_main.sound._play('mail');
				}
			}
			else
				dataSet.add(sDataSet, [aIQAttribute['UID']], aParsedData[aIQAttribute['UID']]);

			if (typeof aHandler == 'object')
				executeCallbackFunction(aHandler);
		}
		break;

	case 'remove':
		try{
			if (aIQAttribute['TYPE']!='result' && aIQAttribute['UID'])
				this.list(sDataSet,aDataPath,aIQAttribute['UID']);
			return true;
		}
		catch(e){}

		return false;

	case 'add':
	case 'synclist':
		try{
			if (aIQAttribute['TYPE'] == 'result' && aIQAttribute['UID']){
				//Proběhla-li synchronizace úspěšně, budeme foldery v accountu listovat
				//var folders = new wm_folders;
				WMFolders.list({'aid':aIQAttribute['UID']},sDataSet,aDataPath,aHandler);
				return true;
			}
			else
			if(aIQAttribute['TYPE'] == 'result' && typeof aHandler == 'object'){
				executeCallbackFunction(aHandler);
				return true;
			}
			else
			if (aIQAttribute['TYPE'] == 'error' && typeof aHandler == 'object')
				executeCallbackFunction(aHandler,aXMLResponse['IQ'][0]['ERROR'][0]['ATTRIBUTES']['UID']);
		}

		catch(e){}
		return false;
	}
};

_me.__mapfolders = function(aFolders){

	if (this.__mapped == sPrimaryAccount) return;

	var test = {},out = {};
	storage.library('gw_others');

	var sTrashFolder = GWOthers.getItem('DEFAULT_FOLDERS', 'trash').split('/')[1];
	if (!aFolders[sTrashFolder])
		test['trash'] = new RegExp('^'+sTrashFolder+'$', "i");

	var sDraftFolder = GWOthers.getItem('DEFAULT_FOLDERS', 'drafts').split('/')[1];
	if (!aFolders[sDraftFolder])
		test['drafts'] = new RegExp('^'+sDraftFolder+'$', "i");

	var sSentFolder = GWOthers.getItem('DEFAULT_FOLDERS', 'sent').split('/')[1];
	if (!aFolders[sSentFolder])
		test['sent'] = new RegExp('^'+sSentFolder+'$', "i");

	for (var itm in aFolders){
		if (aFolders[itm].ARCHIVE)
			dataSet.add('main',['archive_path'],sPrimaryAccount+'/'+itm,true);
		else
		if (aFolders[itm].SPAM)
			dataSet.add('main',['spam_path'],sPrimaryAccount+'/'+itm,true);
		else
		for(var itm2 in test)
			if (itm.match(test[itm2])){
				out[itm2] = sPrimaryAccount+'/'+itm;
				test[itm2] = null;
				delete test[itm2];
			}
	}

	if (!Is.Empty(out))
		GWOthers.set('DEFAULT_FOLDERS',out,'storage');

	this.__mapped = sPrimaryAccount;
};

//********************************************************************************
//Pomocná funkce realizující převod z "XML" pole do Dataset struktur
//********************************************************************************

_me.parse = function(aData){
	try{
		var aFrame = aData['IQ'][0]['QUERY'][0]['ACCOUNT'];
		var aResult={};
		var aResultFrame;

		for(var nAccNum in aFrame){
			aResultFrame = {};

			for(var sTag in aFrame[nAccNum])
				if (sTag != 'ATTRIBUTES'){
					if (sTag == 'ACL'){
					    var aRights;
						if (aFrame[nAccNum][sTag][0] && (aRights = aFrame[nAccNum][sTag][0].RIGHT)){
							aResultFrame.ACL = {};
							for(var i in aRights)
								aResultFrame.ACL[aRights[i].ATTRIBUTES.EMAIL] = aRights[i].VALUE?aRights[i].VALUE.split(''):[];
						}
						aRights = null;
					}
					else
						aResultFrame[sTag] = aFrame[nAccNum][sTag][0]['VALUE'];
				}


			if (aFrame[nAccNum]['ATTRIBUTES']){
				aResultFrame['GW'] = (aFrame[nAccNum]['ATTRIBUTES']['GW']=='true'?1:0);
				aResultFrame['IM_SUPPORT'] = (aFrame[nAccNum]['ATTRIBUTES']['IM_SUPPORT']=='true'?1:0);
				aResultFrame['SIP_SUPPORT'] = (aFrame[nAccNum]['ATTRIBUTES']['SIP_SUPPORT']=='true'?1:0);
				aResultFrame['SMS_SUPPORT'] = (aFrame[nAccNum]['ATTRIBUTES']['SMS_SUPPORT']=='true'?1:0);
				aResultFrame['PRIMARY'] = (aFrame[nAccNum]['ATTRIBUTES']['PRIMARY']=='true'?1:0);
				aResultFrame['EXPIRED'] = (aFrame[nAccNum]['ATTRIBUTES']['PASSEXPIRED']=='true'?1:0);
				aResultFrame['TYPE'] = (aFrame[nAccNum]['ATTRIBUTES']['TYPE']?aFrame[nAccNum]['ATTRIBUTES']['TYPE']:'user');
			}
			else
				aResultFrame['TYPE'] = 'user';

			//SET GLOBAL ACCOUNT VARIABLES!!
			if (aResultFrame['PRIMARY']){
				dataSet.add('main',['fullname'],aResultFrame['FULLNAME']);
				dataSet.add('main',['user'],aResultFrame['USERNAME']);
				dataSet.add('main',['account'],aFrame[nAccNum]['ATTRIBUTES']['UID']);
				dataSet.add('main',['domain'],aFrame[nAccNum]['ATTRIBUTES']['UID'].substr(aFrame[nAccNum]['ATTRIBUTES']['UID'].indexOf('@')+1));

				window.sPrimaryAccount = aFrame[nAccNum]['ATTRIBUTES']['UID'];
				window.sPrimaryAccountType = aResultFrame['TYPE'];
                window.sPrimaryAccountProtocol = aResultFrame['PROTOCOL'];

				window.sPrimaryAccountGW = aResultFrame['GW'];
				window.sPrimaryAccountGWID = aFrame[nAccNum]['ATTRIBUTES']['GW_OWNERID'];
				window.sPrimaryAccountIM = aResultFrame['IM_SUPPORT'];
				window.sPrimaryAccountSIP = aResultFrame['SIP_SUPPORT'];
				window.sPrimaryAccountSMS = aResultFrame['SMS_SUPPORT'];
			}

			aResult[aFrame[nAccNum]['ATTRIBUTES']['UID']] = aResultFrame;
		}

		return aResult;
	}
	catch(e){
		return false;
	}
};

/////////////////////////////////
var accounts = new wm_accounts();
var WMAccounts = accounts;