function wm_upload(){
	this.xmlns = 'upload';
};

wm_upload.inherit(wm_generic);
var _me = wm_upload.prototype;


/*
<upload action="certificate">
<folder>2009-03-03-49ad2d36z8d16</folder>
<file>49ad2d36z8d33</file>
<passphrase>599033</passphrase>
</upload>
*/
_me.certificate = function(sFolder,sFile,sPass,aHandler){
	var request = {UPLOAD:[{ATTRIBUTES:{TYPE:'certificate'},FOLDER:[{VALUE:sFolder}],FILE:[{VALUE:sFile}]}]};

	if (sPass)
	    request.UPLOAD[0].PASSPHRASE = [{VALUE:sPass}];
	    
	this.create_iq(request,[this,'response',['certificate',aHandler]]);
};

_me.ticket = function(sFolder,sFile,aHandler){
	var request = {UPLOAD:[{FOLDER:[{VALUE:sFolder}],FILE:[{VALUE:sFile}]}]};
	this.create_iq(request,[this,'response',['ticket',aHandler]]);
};

_me.file2xml = function(sFolder,sFile,sJid,aHandler){
	var request = {UPLOAD:[{FOLDER:[{VALUE:sFolder}],FILE:[{VALUE:sFile}],JID:[{VALUE:sJid}],ATTRIBUTES:{ACTION:'file2xml'}}]};
	this.create_iq(request,[this,'response',['file2xml',aHandler]],'','set','','',true);
};

_me.data2xml = function(sType,sData,sJid,aHandler){
	var request = {UPLOAD:[{TYPE:[{VALUE:sType}],DATA:[{VALUE:sData}],NAME:[{VALUE:sJid}],JID:[{VALUE:sJid}],ATTRIBUTES:{ACTION:'data2xml'}}]};
	this.create_iq(request,[this,'response',['data2xml',aHandler]],'','set');
};

_me.response = function(aData,sMethodName,aHandler){

	var aXMLResponse = aData['Array'];
	var aIQAttribute = aXMLResponse['IQ'][0]['ATTRIBUTES'];

	switch (sMethodName){
	case 'certificate':
        if (aHandler){
			if (aIQAttribute['TYPE'] == 'result')
				executeCallbackFunction(aHandler,aXMLResponse.IQ[0].QUERY[0].DATA[0]);
			else
				executeCallbackFunction(aHandler,null);
		}

	    break;
	
	case 'ticket':
        if (aHandler){
			if (aIQAttribute['TYPE'] == 'result'){
                var aUpload = aXMLResponse.IQ[0].QUERY[0].UPLOAD[0];
	            executeCallbackFunction(aHandler,{name:aUpload.NAME[0].VALUE,type:aUpload.TYPE[0].VALUE,ticket:aUpload.TICKET[0].VALUE});
			}
			else
				executeCallbackFunction(aHandler);
		}
		break;

	case 'file2xml':
	    if (aIQAttribute['TYPE'] == 'result'){
			var out,h;
			if (aXMLResponse.IQ[0].QUERY[0].DATA && aXMLResponse.IQ[0].QUERY[0].DATA[0].VALUE)
				out = aXMLResponse.IQ[0].QUERY[0].DATA[0].VALUE;
			if (aXMLResponse.IQ[0].QUERY[0].HASH && aXMLResponse.IQ[0].QUERY[0].HASH[0].VALUE)
				h = aXMLResponse.IQ[0].QUERY[0].HASH[0].VALUE;

			executeCallbackFunction(aHandler,out,h);
		}
		break;

    case 'data2xml':
        if (aHandler){
			var h;
			if (aXMLResponse.IQ[0].QUERY[0].HASH && aXMLResponse.IQ[0].QUERY[0].HASH[0].VALUE)
				h = aXMLResponse.IQ[0].QUERY[0].HASH[0].VALUE;

			executeCallbackFunction(aHandler,h);
		}
	}
};