function wm_xmpp(aHandler){
	this.__sid;
	this.__aHandler = aHandler;

	//request buffer
	this.__buffer = {};

	//global httprequest
	this.__http = this.createHTTP();

	//SHA1 hash of vCard photo, used in presence request
	storage.library('wm_upload');
	this.__imageHash = '';
};

/**
 * XMPP Login sequence
 * 2.9.2008 16:45:31
 **/
wm_xmpp.prototype.login = function(aInput,aHandler){
	//step1 (create stream, retrieve authid)
	if (!aInput){
		var gs_serv = GWOthers.getItem('GLOBAL_SETTINGS','xmppserver') || 'localhost',
			gs_port = GWOthers.getItem('GLOBAL_SETTINGS','xmppport');

		this.__http.sendString('<body hold="1" xmlns="http://jabber.org/protocol/httpbind" to="'+ dataSet.get('main',['domain']) +'" route="'+gs_serv+(parseInt(gs_port)>0?':'+parseInt(gs_port):'')+'" wait="180" ver="1.6" />',[this,'login',[aHandler]]);
	}
	else
	if (aInput['Array']){

		aInput = aInput['Array'];

		if (!aInput.BODY){
			if (this.__aHandler)
				executeCallbackFunction(this.__aHandler,'error',aInput);

			return;
		};

		//step2 + step4
		this.__sid = aInput.BODY[0].ATTRIBUTES.SID;

		//step2 (ask wm server for digest)
		if (aInput.BODY[0].ATTRIBUTES.AUTHID)
			auth.get_digest(aInput.BODY[0].ATTRIBUTES.AUTHID,'XMPP',[this,'login',[aHandler]]);
		else
		if (aHandler){
			//ERROR response: <iq type="error"><query><username>admin</username><resource>Webmail</resource><digest>2a6f71a7d41a366bbeafe71e63166c7b70e7522e</digest></query><error code="407">Registration Required</error></iq>
			if (aInput.BODY[0].IQ[0].ATTRIBUTES.TYPE == 'error')
				executeCallbackFunction(aHandler);
			else
				this.vcard('','',[this,'photo_hash',[aHandler]]);
		}
	}
	//step3 (login into Jabber)
	else{
		var aData = {};
			aData.USERNAME	= [{VALUE:dataSet.get('main',['account'])}];
			aData.RESOURCE	= [{VALUE:'Webmail'}];
			aData.DIGEST	= [{VALUE:aInput}];

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:auth'),'set'),'',[this,'login',[aHandler]]);
	}
};
	wm_xmpp.prototype.photo_hash = function(aData,aHandler){
		//Avatar Photo
		if (aData && aData.VCARD && aData.VCARD[0] && (aData = aData.VCARD[0])){
			if (aData.PHOTO && aData.PHOTO[0] && aData.PHOTO[0].TYPE && aData.PHOTO[0].BINVAL){
				var up = new wm_upload();
					up.data2xml(aData.PHOTO[0].TYPE[0].VALUE,aData.PHOTO[0].BINVAL[0].VALUE, sPrimaryAccount,[this,'update_hash',[aHandler]]);

				return;
			}
			else
				this.__imageHash = '';
		}

		if (aHandler)
			executeCallbackFunction(aHandler);
	};
	wm_xmpp.prototype.update_hash = function(sHash,aHandler){
		this.__imageHash = sHash;

		if (aHandler)
			executeCallbackFunction(aHandler);
	};

wm_xmpp.prototype.logout = function(aHandler,bNoRequest){

	this.kill();

	if (this.__sid){
		//<presence type="unavailable"><status>Logged out</status></presence>
		if (!bNoRequest){
			var aData = {STATUS:[{VALUE:'Logged out'}]};
			this.create_body(this.create_presence(aData,'unavailable'),'terminate',[this,'response',['exe']]);
		}

		this.__sid = '';
		this.__imageHash = '';
	}

	if (aHandler)
		executeCallbackFunction(aHandler);
};

////// GATEWAYS //////

/* List
<iq type="get" to="icewarp.com" id="ab07a" >
<query xmlns="http://jabber.org/protocol/disco#items"/>
</iq>


<iq xmlns="jabber:client" type="get" id="5987343346676919001244638385735">
<query xmlns="http://jabber.org/protocol/disco#items"/>
</iq>

<iq from="icewarp.com" type="result" id="ab07a" to="tonda@icewarp.com/Office" >
<query xmlns="http://jabber.org/protocol/disco#items">
<item category="gateway" type="icq" name="ICQ Transport Gateway" jid="icq.icewarp.com" />
<item category="gateway" type="service" name="E-mail Transport" jid="email.icewarp.com" />
</query>
</iq>
*/
wm_xmpp.prototype.gateway_list = function(sDomain, aHandler){
	if (this.__sid){
		var sID = unique_id();
		this.__buffer[sID] = aHandler;

		this.create_body(this.create_iq(this.create_query('','http://jabber.org/protocol/disco#items'),'get', sID, sDomain),'',[this,'response',['exe']]);
	}
};

/*
# Ask for reg info
<iq type="get" to="007guard.com" id="ab4ba" >
<query xmlns="jabber:iq:register"/>
</iq>

<iq from="007guard.com" type="result" id="ab4ba" to="user@merakdemo.com/Work" >
<query xmlns="jabber:iq:register">
<username/>
<password/>
<instructions>Please enter your username and password</instructions>
</query>
</iq>

#Do registration
<iq type="set" to="007guard.com" id="ab48a" >
<query xmlns="jabber:iq:register">
<username>abc</username>
<password>cda</password>
</query>
</iq>
*/
wm_xmpp.prototype.gateway_registr = function(aData, sTo, aHandler){
	if (this.__sid){
		var q = {}, sID = unique_id();
		this.__buffer[sID] = aHandler;

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:register'),aData?'set':'get', sID, sTo),'',[this,'response',['exe']]);
	}
};


////// PRESENCE //////

/**
 * Set client status priority
 * 2.9.2008 16:46:13
 **/
wm_xmpp.prototype.set_status = function(iStatus,sShow,sStatus,aHandler){
	if (this.__sid){

		var sType = '';
		var aData = {};

		if (sShow)
			aData.PRIORITY = [{VALUE:(iStatus || 5)}];

		if (sShow == 'invisible')
			sType = 'invisible';
		else{
			if (sShow)
				aData.SHOW = [{VALUE:sShow}];

			if (sStatus)
				aData.STATUS = [{VALUE:sStatus}];
		}

		//Avatar Update <x xmlns='vcard-temp:x:update'><photo>sha1-hash-of-image</photo></x>
		aData.X = [{ATTRIBUTES:{XMLNS:'vcard-temp:x:update'},PHOTO:[{VALUE:this.__imageHash}]}];

		this.create_body(this.create_presence(aData,sType),'',[this,'response',['exe', aHandler]]);
	}
};

/**
 * DOWNLOAD
 **/
wm_xmpp.prototype.oob_cancel = function(aData, sID, sTo){
	if (this.__sid && sTo){
		var iq = this.create_iq(this.create_query(aData,'jabber:iq:oob'),'error', sID, sTo);
			iq.IQ[0].ERROR = [{ATTRIBUTES:{CODE:406,TYPE:'modify'},'NOT-ACCEPTABLE':[{ATTRIBUTES:{XMLNS:'urn:ietf:params:xml:ns:xmpp-stanzas'}}]}];

		this.create_body(iq,'',[this,'response']);
	}
};

/**
 * UPLOAD
 **/
wm_xmpp.prototype.oob_send = function(sFolder,sFile,sTo,sDesc){
	storage.library('wm_upload');
	var up = new wm_upload();
		up.ticket(sFolder,sFile, [this,'oob_support',[sTo,sDesc]]);
};

wm_xmpp.prototype.oob_support = function(aData,sTo,sDesc){
	//check xmpp
	if (!this.__sid) return;

	if (aData.ticket){
		//check oob support
		var sID = unique_id();
		this.__buffer[sID] = [this,'oob_upload',[aData, sTo, sDesc]];
		this.create_body(this.create_iq(this.create_query('','http://jabber.org/protocol/disco#info'),'get', sID, sTo),'',[this,'response',['exe']]);
	}
	//error creating ticket
	else
		gui._create('ticket_error','frm_alert','','','','','IM::ERROR_TICKET');
};

wm_xmpp.prototype.oob_upload = function(aData, aTicket, sTo, sDesc){
	//check xmpp
	if (!this.__sid) return;

	//build URL
	var sURL = document.location.href;
		sURL = sURL.substr(0,sURL.lastIndexOf('/')+1) + 'server/download.php/ticket/'+ encodeURIComponent(aTicket.ticket) +'/'+ aTicket.name;

	//check OOB support
	var f;
	if (aData && aData.QUERY && aData.QUERY[0] && (f = aData.QUERY[0].FEATURE))
		for (var i in f)
			if (f[i].ATTRIBUTES && f[i].ATTRIBUTES.VAR == 'jabber:iq:oob'){

				//send OOB query
				var sID = unique_id(),
					aQ = {URL:[{VALUE:sURL}],DESC:[{VALUE:sDesc}]};

				this.__buffer[sID] = [this,'oob_finish',[aTicket]];

				this.create_body(this.create_iq(this.create_query(aQ,'jabber:iq:oob'),'set', sID, sTo),'',[this,'response',['exe']]);
				return;
			}

	//OOB unsupported, send message with link
	var sBody = getLang('IM::FILE_MESSAGE',[sDesc || '', sURL]);
	this.message(sTo, sBody);
};

wm_xmpp.prototype.oob_finish = function (aData){
	if (aData){
		if (aData.ERROR)
			gui._create('ticket_error','frm_alert','','','','','IM::FILE_CANCEL');
		else
		if (aData.ATTRIBUTES && aData.ATTRIBUTES.TYPE == 'error')
			gui._create('ticket_error','frm_alert','','','','','IM::FILE_ERROR');
		else
			gui._create('ticket_error','frm_alert','','','','','IM::FILE_OK');
	}
};


/**
 * ROSTER
 **/
wm_xmpp.prototype.roster_get = function(aHandler){
	if (this.__sid)
		this.create_body(this.create_iq(this.create_query('','jabber:iq:roster'),'get'),'',[this,'response',['exe', aHandler]]);
};

/**
 * HISTORY
 **/
wm_xmpp.prototype.history_get = function(aData, aHandler){
/*
<retrieve xmlns='urn:xmpp:archive' with='juliet@capulet.com/chamber' start='1469-07-21T02:56:15Z'> // start UTC time
[<body>optional body text search</body>]
<set xmlns='http://jabber.org/protocol/rsm'>
<max>100</max>
[<after></after> // after x secs from start]
[<before/> // from the end]
[<before></before> // backwards before x secs from start]
</set>
</retrieve>
*/

	var q = {RETRIEVE:[{ATTRIBUTES:{XMLNS:'urn:xmpp:archive',WITH:aData.from},SET:[{ATTRIBUTES:{XMLNS:'http://jabber.org/protocol/rsm'}}]}]};

	if (aData['start'])
		q.RETRIEVE[0].ATTRIBUTES.START = typeof aData['start'] == 'date'?aData['start'].format('imDateTime'):aData['start'];

	if (aData['search'])
		q.RETRIEVE[0].BODY = [{VALUE:aData['search']}];

	if (aData['max'])
		q.RETRIEVE[0].SET[0].MAX = [{VALUE:aData['max']}];

	if (typeof aData['before'] != 'undefined')
		q.RETRIEVE[0].SET[0].BEFORE = [{VALUE:aData['before'] || ''}];

	if (aData['after'])
		q.RETRIEVE[0].SET[0].AFTER = [{VALUE:aData['after']}];

	var sID = unique_id();
	this.__buffer[sID] = aHandler;

	if (this.__sid)
		this.create_body(this.create_iq(q,'get',sID),'',[this,'response',['exe']]);
};

/**
 * USER
 **/
wm_xmpp.prototype.user_remove = function(aJID, aHandler){
	/*
	Supports multiple IQ
	<iq type="set" id="aadaa" >
	<query xmlns="jabber:iq:roster">
	<item subscription="remove" jid="asd@merakdemo.com" />
	</query>
	</iq>

	Remove gateway
	<iq type="set" to="monitor.icewarp.com" id="aaf1a" ><query xmlns="jabber:iq:register"><remove/></query></iq>
	 <iq xmlns="jabber:client" type="set"><query xmlns="jabber:iq:register"><remove/></query></iq>
	*/
	

	if (this.__sid && aJID.length){

		var aData, aTmp = {IQ:[]};
		for(var i in aJID){
			aData = {ITEM:[{ATTRIBUTES:{subscription:'remove',jid:aJID[i]}}]};

			aTmp.IQ.push(this.create_iq(this.create_query(aData,'jabber:iq:roster'),'set').IQ[0]);

			//un-registr gateway
			if (aJID[i].indexOf('@')<0)
            	aTmp.IQ.push(this.create_iq(this.create_query({'REMOVE':[{}]},'jabber:iq:register'),'set','',aJID[i]).IQ[0]);
		}

		if (aTmp.IQ.length)
			this.create_body(aTmp,'',[this,'response',['exe', aHandler]]);
	}
};

wm_xmpp.prototype.user_add = function(sJID, sName, sGroup, aHandler){
	this.user_group(sJID, sName, sGroup, [this,'user_subscribe',[sJID,aHandler]]);
};

wm_xmpp.prototype.user_group = function(sJID, sName, sGroup, aHandler){
	/*
	<iq type="set" id="ab16a" >
	<query xmlns="jabber:iq:roster">
	<item jid="domain@merakdemo.com" >
	<group>skupina</group>
	</item>
	</query>
	</iq>
	*/
	if (this.__sid && sJID){
		var aData = {ITEM:[{ATTRIBUTES:{jid:sJID}}]};
		
		if (sGroup)
			aData.ITEM[0].GROUP = [{VALUE:sGroup}];

		if (sName)
			aData.ITEM[0].ATTRIBUTES.NAME = sName;

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:roster'),'set'),'',[this,'response',['exe', aHandler]]);
	}
};

//request subscription
wm_xmpp.prototype.user_subscribe = function(sJID,aHandler){
	//<presence type="subscribe" to="user@merakdemo.com" >
	//<nick xmlns="http://jabber.org/protocol/nick">zork</nick>
	//</presence>

	//DORESIT NICK (muj)

	this.create_body(this.create_presence('','subscribe',sJID),'',[this,'response',['exe',aHandler]]);
};
//re-send subscription
wm_xmpp.prototype.user_subscribed = function(sJID,aHandler){
	//<presence type="subscribed" to="user@merakdemo.com" />
    if (this.__sid && sJID){
		this.create_body(this.create_presence('','subscribed',sJID),'',[this,'response',['exe',aHandler]]);
		this.create_body(this.create_presence('','subscribe',sJID),'',[this,'response']);
	}
};
//remove subscription
wm_xmpp.prototype.user_unsubscribed = function(sJID,aHandler){
	//<presence type="unsubscribed" to="user@merakdemo.com" />
    if (this.__sid && sJID)
		this.create_body(this.create_presence('','unsubscribed',sJID),'',[this,'response',['exe',aHandler]]);
};

wm_xmpp.prototype.user_rename = function(sJID,sName,sGroup,aHandler){
	/*
	<iq type="set" id="ab21a" >
	<query xmlns="jabber:iq:roster">
	<item name="admin" jid="admin@merakdemo.com" />
	</query>
	</iq>
	*/
	if (this.__sid && sJID){
		var aData = {ITEM:[{ATTRIBUTES:{NAME:sName,JID:sJID}}]};

		if (sGroup)
			aData.ITEM[0].GROUP = [{VALUE:sGroup}];

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:roster'),'set'),'',[this,'response',['exe', aHandler]]);
	}
};


/**
 * MESSAGE
 **/
wm_xmpp.prototype.message = function(sTo, sBody, aHandler){
	if (this.__sid && sTo){
		var aData = {BODY:[{VALUE:sBody}],ACTIVE:[{ATTRIBUTES:{XMLNS:"http://jabber.org/protocol/chatstates"}}]};
		this.create_body(this.create_message(aData,'chat',sTo),'',[this,'response',['exe', aHandler]]);
	}
};

wm_xmpp.prototype.vcard = function(sTo, aValue, aHandler){
	/*
	GET
	<iq type="get" to="admin@merakdemo.com" id="aabda" >
	<vCard xmlns="vcard-temp" version="2.0" prodid="-//HandGen//NONSGML vGen v1.0//EN" />
	</iq>

	SET
	<iq type="set" id="aabea" >
	<vCard xmlns="vcard-temp" version="2.0" prodid="-//HandGen//NONSGML vGen v1.0//EN" >
	<FN>Administrator</FN>
	<NICKNAME>zork</NICKNAME>
	<BDAY>11.09.1983</BDAY>
	<URL>www</URL>
	</vCard>
	</iq>
	*/

	if (this.__sid){

		var aData = {vCard:[{}]};

		if (aValue)
			aData.vCard[0] = aValue;

		aData.vCard[0].ATTRIBUTES = {XMLNS:"vcard-temp",version:'2.0',prodid:'-//HandGen//NONSGML vGen v1.0//EN'};

		//add to response buffer
		var sID;
		if (aHandler){
			sID = unique_id();
			this.__buffer[sID] = aHandler;
		}

		//SET is CaseSensitive
		if (aValue){
			var aRequest = {'body':[{ATTRIBUTES:{XMLNS:'http://jabber.org/protocol/httpbind', sid:this.__sid}}]};
				aRequest['body'][0].iq = [aData];
				aRequest['body'][0].iq[0].ATTRIBUTES = {to:(sTo || dataSet.get('main',['account'])), type:'set'};

			if (aHandler)
				aRequest['body'][0].iq[0].ATTRIBUTES.id = sID;

			var	http = this.createHTTP();
				http.sendArray(aRequest,[this, 'response',['exe']],true);
		}
		else
			this.create_body(this.create_iq(aData,aValue?'set':'get',sID,sTo || dataSet.get('main',['account'])),'',[this, 'response',['exe']]);
	}
};


/**
 * STORAGE
 * 3.9.2008 11:51:10
 **/
wm_xmpp.prototype.storage_get = function (sStorage,aHandler){
	if (this.__sid){
		var aData = {WEBMAIL_PRO:[]};
		
		if (sStorage){
			var tmp = {};
				tmp[sStorage] = [];
			aData.WEBMAIL_PRO.push(tmp);
		}

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:private'),'get'),'',aHandler);
	}
};

wm_xmpp.prototype.storage_set = function (sStorage, aIn, aHandler){
	if (this.__sid){

		var aStor = {};
			aStor[sStorage] = [{VALUE:arrToString(aIn)}];

		var aData = {WEBMAIL_PRO:[]};
			aData.WEBMAIL_PRO.push(aStor)

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:private'),'set'),'',aHandler);
	}
};


/**
 * Listen to event
 **/
wm_xmpp.prototype.listen = function(aHandler){
	if (this.__listenTimeout)
		window.clearTimeout(this.__listenTimeout);

	if (this.__killTimeout)
		window.clearTimeout(this.__killTimeout);

	if (this.__sid){
		var me = this;

		this.__http.createDocument();
		this.__http.sendString('<body sid="'+ this.__sid +'" xmlns="http://jabber.org/protocol/httpbind"></body>',[this, 'response', ['listen',aHandler]]);

		this.__killTimeout = setTimeout(function(){ if (me && me.kill) me.kill(); },210000);
	}
};

wm_xmpp.prototype.kill = function(){
	if (this.__listenTimeout)
		window.clearTimeout(this.__listenTimeout);

	if (this.__killTimeout)
		window.clearTimeout(this.__killTimeout);

	if (this.__http && this.__http.oXMLHttp && this.__http.oXMLHttp.readyState && this.__http.oXMLHttp.readyState!=4)
		this.__http.oXMLHttp.abort();
};

wm_xmpp.prototype.response = function(aData,sType,aHandler){

	if (!aData) return;

	aData = aData.Array;

	if (aData.BODY){

		//Recreate Bind
		if (sType == 'listen' && this.__sid)
			this.listen();

		aData = aData.BODY[0];

		//REQUEST
		var attr;
		if (aData.IQ){
			for(var i in aData.IQ){
				if (aData.IQ[i].QUERY){
					var query = aData.IQ[i].QUERY[0];
					if (query.ATTRIBUTES)
						switch (query.ATTRIBUTES.XMLNS){
						//ROSTER
						case 'jabber:iq:roster':
							if (this.__aHandler)
								executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['roster',query]]);
							break;
						//OOB SUPPORT (for download)
						case 'http://jabber.org/protocol/disco#info':

							if (aData.IQ[i].ATTRIBUTES.TYPE == 'get')
								this.create_body(this.create_iq(this.create_query({FEATURE:[{ATTRIBUTES:{VAR:'jabber:iq:oob'}}]},'http://jabber.org/protocol/disco#info'), 'result', aData.IQ[i].ATTRIBUTES.ID, aData.IQ[i].ATTRIBUTES.FROM),'',[this,'response']);

							break;
						//DOWNLOAD
						case 'jabber:iq:oob':
							if (this.__aHandler && aData.IQ[i].ATTRIBUTES.TYPE == 'set'){
								query.FROM = [{VALUE:aData.IQ[i].ATTRIBUTES.FROM}];
								query.ID = [{VALUE:aData.IQ[i].ATTRIBUTES.ID}];
								executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['download',query]]);
							}
							break;
						}
				}

				var id = aData.IQ[i].ATTRIBUTES?aData.IQ[i].ATTRIBUTES.ID:'';
				if (id && this.__buffer[id]){
					executeCallbackFunction(this.__buffer[id],aData.IQ[i]);
					delete this.__buffer[id];
				}
			}
			
			for(var i in aData.SI){
				if (this.__aHandler)
					executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['download',query]]);
			}
		}
				
		//PRESENCE
		if (aData.PRESENCE)
			for(var i in aData.PRESENCE){
				attr = aData.PRESENCE[i].ATTRIBUTES;

				if (aData.PRESENCE[i].ERROR){
					executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['error',[aData.PRESENCE[i].ERROR[0]]]]);
					return;
				}

				switch(attr.TYPE){
				//Someone added me into roster
				case 'subscribe':
					// --> <presence to="admin@merakdemo.com" from="user@merakdemo.com" type="subscribe"><status/></presence>
					//document.title = attr.FROM +' ask for subscription';

					//auto subscribe users
					// <-- <presence type="subscribed || unsubscribed" to="user@merakdemo.com" />
					//this.create_body(this.create_presence('','subscribed',attr.FROM),'',[this,'response']);

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['subscribe',aData.PRESENCE[i]]]);

				break;

				case 'unavailable':

					//document.title = attr.FROM +' is Offline';

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['unavailable',aData.PRESENCE[i]]]);

				break;

				case 'subscribed':
					//document.title = attr.FROM +" poslal opravneni";

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['subscribed',aData.PRESENCE[i]]]);
				break;

				case 'unsubscribed':
					//document.title = attr.FROM +" odebral opravneni";

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['unsubscribed',aData.PRESENCE[i]]]);

					//neopravneny offline
				break;

				//Someone changed his status
				default:
					//inspect2({presence:aData});

					/*
					<presence from="user@merakdemo.com/t61" to="admin@merakdemo.com/webmail">
						<show>chat</show>
						<priority>5</priority>
						<status>cumim na bednu</status>
						<c xmlns="http://jabber.org/protocol/caps" node="http://psi-im.org/caps" ver="0.11-dev-rev8" ext="cs ep-notify html" />
					</presence>*/

					//document.title = attr.FROM +' '+ (aData.PRESENCE[i].SHOW?aData.PRESENCE[i].SHOW[0].VALUE:'Online') +' ('+ (aData.PRESENCE[i].PRIORITY?aData.PRESENCE[i].PRIORITY[0].VALUE:'') +') ' + (aData.PRESENCE[i].STATUS?aData.PRESENCE[i].STATUS[0].VALUE:'');

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['state_change',aData.PRESENCE[i]]]);
				}
			}

		//MESSAGE
		if (aData.MESSAGE)
			for(var i in aData.MESSAGE){

				//Arrived
				if (this.__aHandler){

					if (aData.MESSAGE[i].ERROR){
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['error',aData.MESSAGE[i].ERROR[0]]]);
						return;
					}

					if (aData.MESSAGE[i].COMPOSING)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['composing',aData.MESSAGE[i].ATTRIBUTES.FROM]]);
					if (aData.MESSAGE[i].PAUSED)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['paused',aData.MESSAGE[i].ATTRIBUTES.FROM]]);

					if (aData.MESSAGE[i].BODY)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['message',aData.MESSAGE[i]]]);
				}
			}


		if (!aData.IQ && !aData.MESSAGE && !aData.PRESENCE){
			//document.title = 'connection expired, rebind?';
		}
	}
	else
	//Status Error
	if (aData.IQ){

		//<iq type="error"><error uid="offline" status="410">Connection Lost</error></iq>
		if (aData.IQ[0].ERROR){

			var attr = aData.IQ[0].ERROR[0].ATTRIBUTES;

			//Session is lost
			if (attr.STATUS == 410){
				if (this.__aHandler)
					this.logout([this.__aHandler[0],this.__aHandler[1],['logout']],true);
				else
					this.logout('',true);
			}
			else
			if (!attr.STATUS){
				var me = this;
				this.__listenTimeout = window.setTimeout(function(){if (me && me.listen) me.listen();},5000);
			}

			return;
		}
	}
	
	//handle response from other then .listen method
	if (sType == 'exe' && aHandler)
		executeCallbackFunction(aHandler);
};

/**
 * bind controler object (obj_im.js)
 **/
wm_xmpp.prototype.bind = function(aHandler){
	this.__aHandler = aHandler;
};
/**
 * AUXILIARY FUNCTIONS
 **/
wm_xmpp.prototype.init = function(){
	this.login('',[this,'listen']);
};

wm_xmpp.prototype.createHTTP = function(){
	var http = new cHttpRequest();
		http.sURL = '/wcs/';
		http.noLoader = true;

	return http;
};



wm_xmpp.prototype.create_body = function(aData,sType,oResponse){
	var aRequest = {};

	if (aData)
		aRequest.BODY = [aData];
	else
		aRequest.BODY = [{}];

	aRequest.BODY[0].ATTRIBUTES = {XMLNS:'http://jabber.org/protocol/httpbind'};

	if (sType)
		aRequest.BODY[0].ATTRIBUTES.TYPE = sType;

	//add SID
	if (this.__sid)
		aRequest.BODY[0].ATTRIBUTES.SID = this.__sid;

	//create httprequest instance
	var	http = this.createHTTP();
		http.sendArray(aRequest,oResponse);
};

	wm_xmpp.prototype.create_iq = function(aData, sType, sID, sTo){

		var aRequest = {IQ:[{}]};

		if (aData)
			aRequest.IQ = [aData];
			
		if (!aRequest.IQ[0].ATTRIBUTES)
			aRequest.IQ[0].ATTRIBUTES = {};
			
		aRequest.IQ[0].ATTRIBUTES.XMLNS = "jabber:client";

		if (sType)
			aRequest.IQ[0].ATTRIBUTES.TYPE = sType;
			
		if (sTo)
			aRequest.IQ[0].ATTRIBUTES.TO = sTo;
			
		if (sID)
			aRequest.IQ[0].ATTRIBUTES.ID = sID;
			
		return aRequest;
	};

		wm_xmpp.prototype.create_query = function(aData,sXMLns){

			var aRequest = {'QUERY':[{}]};

			if (aData)
				aRequest.QUERY = [aData];

			if (sXMLns){
				if (!aRequest.QUERY[0].ATTRIBUTES)
					aRequest.QUERY[0].ATTRIBUTES = {};

				aRequest.QUERY[0].ATTRIBUTES['XMLNS'] = sXMLns;
			}

			return aRequest;
		};

	wm_xmpp.prototype.create_presence = function(aData,sType,sTo){

		var aRequest = {PRESENCE:[{}]};

		if (aData)
			aRequest.PRESENCE = [aData];

		if (!aRequest.PRESENCE[0].ATTRIBUTES)
			aRequest.PRESENCE[0].ATTRIBUTES = {};

		aRequest.PRESENCE[0].ATTRIBUTES.XMLNS = "jabber:client";
		aRequest.PRESENCE[0].ATTRIBUTES.FROM = dataSet.get('main',['account']);

		if (sType)
			aRequest.PRESENCE[0].ATTRIBUTES.TYPE = sType;

		if (sTo)
			aRequest.PRESENCE[0].ATTRIBUTES.TO = sTo;
			
		return aRequest;
	};

	wm_xmpp.prototype.create_message = function(aData, sType, sTo){
		var aRequest = {MESSAGE:[]},
			tmp = {};

		if (typeof sTo == 'string')
			sTo = [sTo];

		for (var i in sTo)
			if (sTo[i]){
				if (aData)
					tmp = clone(aData,true);
				else
				    tmp = {};

				if (!tmp.ATTRIBUTES)
					tmp.ATTRIBUTES = {};

				if (sType)
					tmp.ATTRIBUTES.TYPE = sType;

				tmp.ATTRIBUTES.TO = sTo[i];

				aRequest.MESSAGE.push(tmp);
			}

		return aRequest;
	};