#!/bin/bash
#
# IceWarp Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: icewarpd.sh - icewarpd launch script
# version: 1.0
#

# init working dir
pushd "$(pwd)" &> /dev/null
WORK_DIR=$(dirname "$0")
cd "$WORK_DIR" &> /dev/null
if [ $? -ne 0 ]
    then
	echo "Can not change directory to ${WORK_DIR}"
	exit 1
fi

# include functions
if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ./scripts/inc/functions.sh
fi

# start icewarpd
export LD_LIBRARY_PATH=${SERVER_LD_LIBRARY_PATH}:${LD_LIBRARY_PATH}
./icewarpd $*
RET=$?

# restore working dir
popd &> /dev/null
exit $RET
