#!/bin/bash
#
# IceWarp Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: php.sh - server internal script
# version: 1.0
#

# init working dir
pushd "$(pwd)" &> /dev/null
WORK_DIR=$(dirname "$0")
cd "$WORK_DIR" &> /dev/null
if [ $? -ne 0 ]
    then
	echo "Can not change directory to ${WORK_DIR}"
	exit 1
fi

# include functions
if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ./inc/functions.sh
fi

# include daemon functions
source ./inc/daemonlib.sh

# test for argument
if [ "x$1" == "x" ]; then
    exit -1
fi

# start PHP, first argument is script name
executephp "$1"

# restore working dir
popd &> /dev/null
exit 0
