#!/bin/bash
#
# IceWarp Server
# (c) IceWarp Ltd. 2008
#
#       All rights reserved.
#
# http://www.icewarp.com
#
# file: phpd.sh - server internal script
# version: 1.0
#

# init working dir
pushd "$(pwd)" &> /dev/null
WORK_DIR=$(dirname "$0")
cd "$WORK_DIR" &> /dev/null
if [ $? -ne 0 ]
    then
	echo "Can not change directory to ${WORK_DIR}"
	exit 1
fi

# include functions
if [ -z "$FUNCTIONS_INCLUDED" ]
    then
	source ./inc/functions.sh
fi

# include daemon functions
source ./inc/daemonlib.sh

# parse command line arguments
# look for argument: WebAppMaxThreads which is number of forked processes in PHP
PHP_FCGI_PROCESSES=8
for i in $*
do
    case `echo $i | tr a-z A-Z` in
	WEBAPPMAXTHREADS=*)
	    PHP_FCGI_PROCESSES=`echo $i | sed 's/[-a-zA-Z0-9]*=//'`
	    ;;
    esac
done

# start PHP
startphp "$PHP_FCGI_PROCESSES"

# restore working dir
popd &> /dev/null
exit 0
