<?php
 define('CHALLENGE_DB_VERSION','2');define(SHAREDLIB_PATH,get_cfg_var('icewarp_sharedlib_path'));require_once(SHAREDLIB_PATH.'system.php');slSystem::import('system/singleton');slSystem::import('system/variable');slSystem::import('error/exception');slSystem::import('api/api');slSystem::import('api/domain');slSystem::import('api/account');slSystem::import('tools/crypt');slSystem::import('tools/date');slSystem::import('tools/filesystem');slSystem::import('mail/mail');require_once('quarantine.php');require_once('spam.php');require_once('report.php');require_once('user.php');class ChallengeApplication{static protected$instance;public$version;public$os;private$mode;private$logging;private$path;private$settings;private$language;private$report;private$quarantine;private$spam;private$admin;private$spamAdmin;private$quarantineAdmin;private$reportSent;private$qCount;private$sCount;private$adminAccounts;private$activeAccounts;public$reportSmtpServer;public$reportSmtpPort;public$reportSender;public$reportFrom;protected function __construct(){$api=IcewarpAPI::instance('Challenge');$this->version=$api->GetProperty('C_Version');$this->os=$api->GetProperty('C_OS');$this->setPath('spam',$api->GetProperty('C_SpamPath'));$this->setPath('config',$api->GetProperty('C_ConfigPath'));$this->setPath('install',$api->GetProperty('C_InstallPath'));$this->setPath('mail',$api->GetProperty('C_System_Storage_Dir_MailPath'));$this->setPath('reports',$this->path['spam'].'reports/');if(!is_dir($this->getPath('reports'))){slToolsFilesystem::mkdir_r($this->path['reports']);}$settingsFile=$this->getPath('spam').'spam.dat';$this->settings=$this->parseSettingsFile($settingsFile);if(!isset($_REQUEST['lang'])||!$_REQUEST['lang']){$language=$this->getSettings('SpamLang');}else{$language=$_REQUEST['lang'];}if(!$language){$language="en";}$languageFile="lang/".slToolsFilesystem::securepath($language)."/lang.xml";$this->language=$this->parseLanguageFile($languageFile);$this->parseSMTPSettings();$bypassFile=$this->getPath('reports').'bypass.dat';if(file_exists($bypassFile)){$this->bypass=file($bypassFile);foreach($this->bypass as$key=>$val){$this->bypass[$key]=trim($val);}}$this->database['type']='sqlite';$this->database['host']=$this->getPath('reports').'reports.db';$this->database['name']='';$this->database['user']='';$this->database['pass']='';$this->qCount=0;$this->sCount=0;$this->reportSent=false;try{$logLevel=$this->getSettings('SpamReportsLogLevel');}catch(Exception$e){$logLevel=0;}$this->setLogging($logLevel);$this->setDebugging($logLevel>1);}static public function instance(){if(!isset(self::$instance)){self::$instance=new ChallengeApplication();}return self::$instance;}public function error($msg){throw new Exception($msg);}public function message($msg){static$msgCount;$logging=$this->getLogging();switch($logging){case null:case false:case'':case 0:break;case 1:echo'.';if($msgCount % 200==0){echo'<br/>';}break;case 2:print_r($msg);echo'<br/>';$api=IcewarpAPI::instance();$api->DoLog($this->id,13,'Challenge',$time."\t".strip_tags($msg));break;}$msgCount++;}public function setStartTime($t,$m){$this->t=$t;$this->m=$m;}public function duration(){return(time()-$this->t+microtime()-$this->m);}private function start($action,$id='challenge'){if($this->isRunning($id)){$this->error('challenge_already_running');}else{switch($action){case'report':$this->cache=ChallengeCache::instance($this);$this->report=Report::instance($this->cache);$this->spam=Spam::instance($this->cache);$this->quarantine=Quarantine::instance($this->cache);$this->admin=ChallengeCacheTable::instance('ChallengeCacheTable','admin',$this->cache);$this->spamAdmin=ChallengeCacheTable::instance('ChallengeCacheTable','spam_admin',$this->cache);$this->quarantineAdmin=ChallengeCacheTable::instance('ChallengeCacheTable','quarantine_admin',$this->cache);$this->time=time();$this->hash=slToolsCrypt::createHash();$report=array('rep_hash'=>$this->hash,'rep_time'=>$this->time);$r=$this->report->create($report);$this->id=$r->getID();break;default:break;}}}private function stop($action,$id='challenge'){switch($action){case'report':$cache=ChallengeCache::instance($this);if($this->adminAccounts){$this->processSpamAdmin($this->adminAccounts);}if(!$this->reportSent){$this->report->delete($this->id);}$api=IcewarpAPI::instance();$activeAccounts=count($this->activeAccounts);$adminAccounts=count($this->adminAccounts);$time=$this->duration();if($this->getLogging()>0){$api->DoLog($this->id,13,'Challenge',$time."\t".$activeAccounts."\t".$adminAccounts."\t".$this->sCount."\t".$this->qCount);}break;case'reset':@unlink($this->database['host']);break;}icewarp_releaselock($id);}private function isRunning($id='challenge'){return!icewarp_getlock($id);}public function setLogging($level){$this->logging=$level;}public function getLogging(){return$this->logging;}public function setDebugging($level){$this->debug=$level;}public function getDebugging(){return$this->debug;}public function setPath($index,$path){$this->path[$index]=$path;}public function getPath($index){if(!isset($this->path[$index])){$this->error('challenge_invalid_path_variable:'.$index);}return$this->path[$index];}public function getSettings($index){if(!isset($this->settings[$index])){$this->error('challenge_invalid_setting_variable:'.$index);}return$this->settings[$index];}public function getLanguage($index){$val=slVariable::getDotted($index,$this->language);if(!isset($val)){$val='';}return$val;}public function run($action,$domain='',$account=''){$this->filterDomain=$domain;$this->filterAccount=$account;$this->start($action);$this->iterateAccounts($action.'Callback');$this->stop($action);}public function setMode($mode){$this->mode=$mode;}public function isBypass($value){if(in_array($value,$this->bypass,false)){if($value==$this->filterDomain||$value==$this->filterAccount.'@'.$this->filterDomain){return false;}else{$this->message('Object bypassed : '.$value);return true;}}else{return false;}}private function iterateAccounts($callback){$api=IcewarpAPI::instance();$account=new IcewarpAccount();$domain=new IcewarpDomain();$domainCount=$api->GetDomainCount();for($i=0;$i<$domainCount;$i++){$domainName=$api->GetDomain($i);if($this->isBypass($domainName)){continue;}if($this->filterDomain&&$this->filterDomain!=$domainName){continue;}$this->message("<hr><h2>Processing domain '$domainName'</h2>");$domain->Open($domainName);$domain->spamSupport=$domain->GetProperty('D_ASSupport');$domain->quarantineSupport=$domain->GetProperty('D_QuarantineSupport');if($domain->spamSupport||$domain->quarantineSupport){if($this->filterAccount){$filter=" u_alias like '".$this->filterAccount."'";}else{$filter="";}if(!$account->FindInitQuery($domainName,$filter)){$this->error("API Problem : Icewarp account object retrieval");}while($account->FindNext()){$email=$account->EmailAddress;if($this->isBypass($email)){continue;}$this->message("<h3>processing account '$email'</h3>");if($account->GetProperty("U_Type")){$this->message("Account skipped due to unsupported account type<br>");continue;}$this->$callback($domain,$account);}$account->FindDone();if($domain->GetProperty('D_type')==3){$mode=$this->getSettings('SpamQReportsMode');if($domain->quarantineSupport){$hasRecent=false;$new=array();$this->quarantine->syncBackupDomain($domain->Name,$this->id,$hasRecent,false,false,$new);$items['q']=$this->quarantine->getBackupDomainItems($this->id,$domain->Name,$mode);$rcpItems=$this->splitRecipientItems($items);if(is_array($rcpItems)&&!empty($rcpItems)){foreach($rcpItems as$rcp=>$rcpItemList){$hasNew=false;if($rcpItemList['q'])foreach($rcpItemList['q']as$id=>$item){$key=$item->GetProperty('itm_sender').'#'.$item->GetProperty('itm_recipient');if(isset($new[$key])){$hasNew=true;}else{if($mode==0){unset($rcpItemList['q'][$id]);}}}if($mode==1||$hasNew){$this->createMessage($mode+1,0,$rcpItemList,$rcp);}}}}}}else{$this->message('Domain skipped ( no quarantine or spam support )');}}}private function reportCallback(&$domain,&$account){$isAdmin=false;$items=array();$user=new ChallengeUser($account);if($user->isSpamAdmin()){$this->adminAccounts[]=$account->EmailAddress;$isAdmin=true;}$spamMode=$domain->spamSupport?$user->getSpamMode():false;$quarantineMode=$domain->quarantineSupport?$user->getQuarantineMode():false;$this->message('Spam Report Mode : <b>'.$this->getModeLabel($spamMode).'</b>');$this->message('Quarantine Report Mode : <b>'.$this->getModeLabel($quarantineMode).'</b>');if($spamMode||$quarantineMode){if($spamMode){$hasRecentS=false;$this->spam->sync($user,$this->id,$hasRecentS);$items['s']=$this->spam->getItems($this->id,$account->EmailAddress,$spamMode,$send,false,$hasRecentS,'*','object','itm_sender');}if($quarantineMode){$hasRecentQ=false;$this->quarantine->sync($user,$this->id,$hasRecentQ);$items['q']=$this->quarantine->getItems($this->id,$account->EmailAddress,$quarantineMode,$send,false,$hasRecentQ);}if($hasRecentQ){$this->qCount+=count($items['q']);}if($hasRecentS){$this->sCount+=count($items['s']);}if($send&&!$isAdmin){$this->createMessage($quarantineMode,$spamMode,$items,$account->EmailAddress);$this->reportSent=true;}$this->markAccount($account->EmailAddress,$hasRecentQ,$hasRecentS);}}public function createMessage($quarantineMode,$spamMode,$blockItems,$email){global$stime;$t=time();$m=microtime();$skindata=$this->createMessageData($quarantineMode,$spamMode,$email);$content=$this->createMessageTop($skindata);$content.=$this->createMessageBlock($email,$blockItems,$skindata);$content.=$this->createMessageBottom($skindata);$this->sendReportEmail($skindata,$content);$stime+=(time()-$t+microtime()-$m);}public function createMessageData($quarantineMode,$spamMode,$email){$skindata=$this->getLanguage('list');$url=$this->getSettings('SpamChallengeURL');$url=$url?$url:'http://mail.domain.com:32000/reports/';$link=$url.'a.html';$RecDomain=explode("@",$email);$skindata['RecDomain']=$recipient_domain=$RecDomain[1];$skindata['URL']=str_ireplace("%%recipient_domain%%",$recipient_domain,$link);$skindata['header_sender']=str_ireplace("%%recipient_domain%%",$recipient_domain,$this->reportSender['address']);$skindata['from']=str_ireplace("%%recipient_domain%%",$recipient_domain,$this->reportFrom['address']);$skindata['fromName']=$this->reportFrom['display'];$skindata['report_id']=$this->id;$skindata['report_hash']=$this->hash;$skindata['owner']=$email;$skindata['qmode']=$quarantineMode;$skindata['smode']=$spamMode;$skindata['admin_action']=$this->getLanguage('list.admin_action');$skindata['account_action']=$this->getLanguage('list.account_action');$skindata['intro']=$this->getLanguage('list.intro');$skindata['outro']=$this->getLanguage('list.outro');return$skindata;}public function createMessageTop(&$skindata){return template("skin/default/list_top.tpl",$skindata);}public function createMessageAdminAction(&$skindata){return template("skin/default/list_admin.tpl",$skindata);}private function createMessageBlock($accountID,&$items,&$skindata){$itms_spam=$itms_quarantine=array();if($items['s']){foreach($items['s']as$s){$itm=$s->property;$itm['itm_type']=1;$itm['itm_type_display']=$this->getLanguage('list.type_spam');$itm['itm_display']=$this->getDisplayDateTime($itm['itm_date'],$itm['itm_time']);$itms_spam[]=$itm;}}if($items['q']){foreach($items['q']as$q){$itm=$q->property;$itm['itm_type']=2;$itm['itm_type_display']=$this->getLanguage('list.type_quarantine');$itm['itm_display']=$this->getDisplayDateTime($itm['itm_date'],$itm['itm_time']);$itms_quarantine[]=$itm;}}if($itms_quarantine||$itms_spam){$skindata['id']=$accountID;if($itms_spam){$skindata['items_spam']=$itms_spam;}if($itms_quarantine){$skindata['items_quarantine']=$itms_quarantine;}$result=template('skin/default/list.tpl',$skindata);unset($skindata['items_spam']);unset($skindata['items_quarantine']);return$result;}}public function createMessageBottom(&$skindata){return template('skin/default/list_bottom.tpl',$skindata);}public function sendReportEmail(&$skindata,&$content){$mail=new slMail();$mail->Sender=$skindata['header_sender'];$mail->Host=$this->reportSmtpServer;$mail->Port=$this->reportSmtpPort;$mail->XMailer='IceWarp Mailer '.$this->version;$mail->setFrom($skindata['from'],$skindata['fromName'],false);$mail->setCharset('UTF-8');$mail->setSubject($this->getLanguage('list.msgsubject'));$mail->setBody('',$content);$mail->AddTo($skindata['owner']);$mail->send();}private function resetCallback(&$domain,&$account){$user=new ChallengeUser($account);$user->reset();}private function emptyCallback(&$domain,&$account){}private function testCallback(&$domain,&$account){}private function getModeLabel($mode){switch(intval($mode)){default:case 0:return'Disabled';break;case 1:return'New Items';break;case 2:return'All Items';break;}}private function processSpamAdmin($adminList){$adminCached=$this->admin->retrieve('*',false,false,false,false,false,false,false,'array','email');$this->message("<br/>Processing Spam Administrators");$this->message("===============================");$account=new IcewarpAccount();foreach($adminList as$adminEmail){if(!$adminCached[$adminEmail]){$adminItem=$this->admin->create(array('email'=>$adminEmail));$adminID=$adminItem->getID();}else{$adminID=$adminCached[$adminEmail]['id'];}$this->message("<b>$adminEmail</b> is administrator for following mailboxes ");$account->Open($adminEmail);$admin=new ChallengeUser($account);$qMode=$admin->getQuarantineMode();$sMode=$admin->getSpamMode();if($qMode||$sMode){$accList=$this->parseAdminFile($admin->path['fileAdmin']);$accList=$this->convertAdminList($accList);}$this->sendAdminEmail($adminID,$accList,$admin,$send);unset($adminCached[$adminEmail]);}$this->cache->transaction();if($adminCached){foreach($adminCached as$toDelete){try{$this->admin->delete($toDelete['id']);$this->spamAdmin->delete(false,true,array('admin_id'=>$toDelete['id']));$this->quarantineAdmin->delete(false,true,array('admin_id'=>$toDelete['id']));}catch(Exception$e){}}}$this->cache->commit();}private function sendAdminEmail($adminID,$list,&$adminUser,&$send){$sendBackup=false;$sendOwned=false;$sendAdmin=false;$qMode=$adminUser->getQuarantineMode();$sMode=$adminUser->getSpamMode();$items['s']=$this->spam->getItems($this->id,$adminUser->email,$sMode,$sendOwned,false,$this->isAccountRecentSpam($adminUser->email),'*','object','itm_sender');$items['q']=$this->quarantine->getItems($this->id,$adminUser->email,$qMode,$sendOwned,false,$this->isAccountRecentQuarantine($adminUser->email));$msgFileName=slToolsFilesystem::randomFilename();$msgFile=fopen($msgFileName,'w+');$skindata=$this->createMessageData($qMode,$sMode,$adminUser->email);$top=$this->createMessageTop($skindata);$block=$this->createMessageBlock($adminUser->email,$items,$skindata);$head=$top.$block;$skindata['admin_id']=$adminID;if($list['backup']){$hasRecent=false;$new=array();foreach($list['backup']as$backupDomain){$this->quarantine->syncBackupDomain($backupDomain,$this->id,$hasRecent,$adminID,$this->quarantineAdmin,$new);$items['q']=$this->quarantine->getBackupDomainAdminItems($this->id,$backupDomain,$qMode,$sendBackup,false,$hasRecent,'*','object','id',false,$adminID);}}$hasAdminItems=false;if($sendBackup){$rcpItems=$this->splitRecipientItems($items);if(is_array($rcpItems)&&!empty($rcpItems)){foreach($rcpItems as$rcp=>$rcpItemList){$hasNew=false;if($rcpItemList['q'])foreach($rcpItemList['q']as$id=>$item){$key=$item->GetProperty('itm_sender').'#'.$item->GetProperty('itm_recipient');if(isset($new[$key])){$hasNew=true;}else{if($qMode==0){unset($rcpItemList['q'][$id]);}}}if($qMode==2||$hasNew){$hasAdminItems=true;$block=$this->createMessageBlock($rcp,$rcpItemList,$skindata);fwrite($msgFile,$block);}}}}$domain=ChallengeApplication::getDomainOnly($adminUser->email);if(isset($list['main'][$domain][$adminUser->email])){unset($list['main'][$domain][$adminUser->email]);}$account=new IcewarpAccount();foreach($list['main']as$dom=>$accounts){if($accounts){foreach($accounts as$acc=>$val){$items=array();$items['q']=array();$items['s']=array();$this->message("$acc");if(!$account->Open($acc)){continue;}if($account->GetProperty('u_type')!=0){continue;}if($qMode||$sMode){$hasRecent=false;$user=new ChallengeUser($account);$user->quarantineMode=$qMode;$user->spamMode=$sMode;if($qMode){$this->quarantine->sync($user,$this->id,$hasRecent,$adminID,$this->quarantineAdmin);$items['q']=$this->quarantine->getAdminItems($this->id,$account->EmailAddress,$qMode,$sendAdmin,false,$hasRecent,'*','object','id',false,$adminID);}if($sMode){$this->spam->sync($user,$this->id,$hasRecent,$adminID,$this->spamAdmin);$items['s']=$this->spam->getAdminItems($this->id,$account->EmailAddress,$sMode,$sendAdmin,false,$hasRecent,'*','object','itm_sender',false,$adminID);}if($sendAdmin){$block=$this->createMessageBlock($account->EmailAddress,$items,$skindata);fwrite($msgFile,$block);}}}}}@fclose($msgFile);$bottom=$this->createMessageBottom($skindata);if($sendAdmin||$sendOwned||$sendBackup){$this->reportSent=true;$adminAction=$this->createMessageAdminAction($skindata);if($sendAdmin||$sendBackup){$head.=$adminAction;}if($sendAdmin||$sendBackup){$bottom=$adminAction.$bottom;}$message=$head.file_get_contents($msgFileName).$bottom;$this->sendReportEmail($skindata,$message);}@unlink($msgFileName);}public function splitRecipientItems($items){if(is_array($items['q'])&&!empty($items['q'])){foreach($items['q']as$id=>$quarantineItem){$rcp=$quarantineItem->GetProperty('itm_recipient');$rcpItems[$rcp]['q'][$id]=$quarantineItem;}}return$rcpItems;}public function convertAdminList($accList){$account=new IcewarpAccount();$domain=new IcewarpDomain();$list=array();foreach($accList['domains']as$dom){if($domain->Open($dom)<0){$this->message("API Problem : Could not open domain '$val'");continue;}if($domain->GetProperty('D_Type')==3){$list['backup'][$domain->Name]=$domain->Name;}if(!$account->FindInitQuery($dom,"")){$this->error("API Problem : Icewarp account object retrieval");}while($account->FindNext()){$listAcc=$account->EmailAddress;$listDom=self::getDomainOnly($listAcc);$list['main'][$listDom][$listAcc]=array();}$account->FindDone();}foreach($accList['accounts']as$acc){$list['main'][self::getDomainOnly($acc)][$acc]=array();}return$list;}private function isAccountRecentSpam($account){return$this->activeAccounts[$account]['hasRecentS'];}private function isAccountRecentQuarantine($account){return$this->activeAccounts[$account]['hasRecentQ'];}private function markAccount($email,$hasRecentQ,$hasRecentS){$this->activeAccounts[$email]=array();$this->activeAccounts[$email]['hasRecentQ']=$hasRecentQ;$this->activeAccounts[$email]['hasRecentS']=$hasRecentS;}private function isProcessed($account){return isset($this->activeAccounts[$account]);}private function hasRecent($account){return$this->activeAccounts[$account]['recent'];}public function parseAdminFile($adminFile){$list=array();if(@file_exists($adminFile)){$acclist=file($adminFile);if(count($acclist)){foreach($acclist as$acc){$acc=trim($acc);if(strpos($acc,"@")===false){$list['domains'][]=$acc;}else{$list['accounts'][]=$acc;}}}}return$list;}public function parseSettingsFile($filename){if(!file_exists($filename)){$this->error('challenge_settings_file_missing:'.$filename);}$lines=file($filename);foreach($lines as$line){$data=explode("=",$line,2);$aResult[$data[0]]=trim($data[1]);}return$aResult;}public function parseLanguageFile($filename){if(!file_exists($filename)){$this->error('challenge_language_file_missing:'.$filename);}$languageXML=simplexml_load_file($filename);if(!$languageXML){$this->error('challenge_language_file_corrupted:'.$filename);}$result=array();foreach($languageXML->ITEM as$val){$result[strval($val["id"])]=strval($val["value"]);}foreach($languageXML->LIST->ITEM as$val){$result['list'][strval($val["id"])]=strval($val["value"]);}foreach($languageXML->ACTIONS->children()as$name=>$val){foreach($val->ITEM as$itmKey=>$itmVal){$result['action'][strtolower($name)][strval($itmVal["id"])]=strval($itmVal["value"]);}}foreach($languageXML->QACTIONS->children()as$name=>$val){foreach($val->ITEM as$itmKey=>$itmVal){$result['qaction'][strtolower($name)][strval($itmVal["id"])]=strval($itmVal["value"]);}}return$result;}private function parseSMTPSettings(){$api=IcewarpAPI::instance();$mailServer="127.0.0.1";$port=$api->GetProperty("C_System_Services_SMTP_Port");$globServer=$api->GetProperty("C_System_Services_BindIPAddress");if($globServer!=""){$mailServer=$globServer;}$fname=$this->getPath('config').'servicebind.dat';if(@file_exists($fname)){$binding=@file_get_contents($fname);$binds=explode("\n",trim($binding));if(count($binds)){foreach($binds as$val){$items=explode(";",$val);if($items[0]=="SMTP"){if($items[1]!="")$mailServer=$items[1];if($items[2]!="")$port=$items[2];break;}}}}$this->reportSmtpServer=$mailServer;$this->reportSmtpPort=$port;$sender=$this->getSettings("SpamReportMailSender");$from=$this->getSettings("SpamReportMailFrom");$sender=mailparse_rfc822_parse_addresses($sender);$this->reportSender=reset($sender);if(!$from){$this->reportFrom=$this->reportSender;}else{$from=mailparse_rfc822_parse_addresses($from);@$this->reportFrom=reset($from);}}static public function getFileTime($file,&$date,&$time){if(file_exists($file)){$udate=filemtime($file);$udate=slToolsDate::fileTimeFix($udate);$date=slToolsDate::unix2calendardate($udate);$time=slToolsDate::unix2calendartime($udate);}else{$date=$time=0;}}static private function markFileTime($file,&$date,&$time){$date=0;$time=0;$list=array();self::getFileTime($file,$date,$time);@touch($file);}static public function getAddressOnly($address){$indL=strpos($address,"<");$indR=strpos($address,">");if($indL===false||$indR===false){return trim($address);}return trim(substr($address,$indL+1,$indR-$indL-1));}static public function getDomainOnly($email){return mb_substr($email,mb_strpos($email,'@',0,'utf-8')+1,mb_strlen($email));}static public function getDisplayDateTime($date,$time){$app=ChallengeApplication::instance();$api=IcewarpAPI::instance();$unixtime=jdtounix($date);$unixtime+=$time;$timezone=$api->GetProperty("C_TimeZone");$unixtime-=$timezone;try{$dateFormat=$app->getSettings('SpamReportsDateFormat');}catch(Exception$e){$dateFormat='d/m/Y';}try{$timeFormat=$app->getSettings('SpamReportsTimeFormat');}catch(Exception$e){$timeFormat='H:i';}$display['date']=date($dateFormat,$unixtime);$display['time']=date($timeFormat,$unixtime);return$display;}static public function extendByZeros($number,$count){$len=$count-strlen($number);for($i=$len;$i>0;$i--)$number="0".$number;return$number;}}?>