<?php
 class Cache extends DB{public$paths;static private$base;public function __construct(&$user){$this->paths=new Paths($user->getTempDir(),$this);parent::__construct($user->getDir());}static public function instance(&$user){if(!isset(self::$base)){self::$base=new Cache($user);}return self::$base;}public function getFolders($account,$class){$this->transaction();$stmt=$this->prepare('SELECT folder_id, name, rights, sync
								FROM folder
								WHERE account_id = ?');$stmt->execute(array($account->accountID));$folders=array();while($row=$stmt->fetch()){$folder=new$class($account,intval($row['folder_id']),$row['name'],intval($row['rights']),$row['sync']);$folders[$folder->name]=$folder;}$this->commit();return$folders;}public function getChildern($account,$class,$folderID){$this->transaction();$stmt=$this->prepare('SELECT folder_id, name, rights, sync
								FROM folder
								WHERE account_id = ? AND parent_folder_id = ?');$stmt->execute(array($account->accountID,$folderID));$folders=array();while($row=$stmt->fetch()){$folder=new$class($account,intval($row['folder_id']),$row['name'],intval($row['rights']),$row['sync']);$folders[$folder->name]=$folder;}$this->commit();if(count($folders)!=0)return$folders;return false;}public function getParent($account,$class,$folderID){$this->transaction();$stmt=$this->prepare('SELECT name, parent_folder_id
								FROM folder
								WHERE folder_id = ? AND account_id = ?');$stmt->execute(array($folderID,$account->accountID));while($row=$stmt->fetch())$parentID=$row['parent_folder_id'];$stmt=$this->prepare('SELECT name
								FROM folder
								WHERE folder_id = ?');$stmt->execute(array($parentID));while($row=$stmt->fetch())$parentName=$row['name'];$type='main';if(isset($parentName))$folder=$account->getFolder($parentName,$type);else$folder=null;$this->commit();return$folder;}private function optimizeOrderBy(&$orderBy,&$fields){$orderBy=str_ireplace(array('header_from','header_to','header_cc','header_bcc','header_sms'),array('sort_from','sort_to','sort_cc','sort_bcc','sort_sms',),$orderBy);$this->addSortColumn('header_from','sort_from',$fields);$this->addSortColumn('header_to','sort_to',$fields);$this->addSortColumn('header_cc','sort_cc',$fields);$this->addSortColumn('header_bcc','sort_bcc',$fields);$this->addSortColumn('header_sms','sort_sms',$fields);}private function addSortColumn($column,$sort_column,&$fields){if(stripos($fields,$column)!==false){if(stripos($fields,$sort_column)===false){$fields.=','.$sort_column;}}}public function getItems($folder,$class,$filter,$orderBy,$offset,$limit,$fields='',$search=false){$selector=$this->getFolderSelector($folder);$this->transaction();if($orderBy){$orderBy=icewarp_sanitize_db_sql($orderBy);if($_SESSION['COLLATE_ENABLE']){$orderBy=Tools::collateOrderBy($orderBy);}$orderBy=' ORDER BY '.$orderBy;$this->optimizeOrderBy($orderBy,$fields);}if($limit)$limit=' LIMIT '.$offset.','.$limit;$filter=$this->composeFilter($filter,$search);$aAllowedFields=array('item_id','rid','size','date','flags','header_from','header_to','header_cc','header_bcc','header_sms','sort_from','sort_to','sort_cc','sort_bcc','sort_sms','message_id','subject','static_flags','priority','color','smime_status','has_attachment','*');if(strpos($fields,'*')!==false){$bFields=false;$sFields='*';}else{$bFields=true;if(substr_count($fields,'item_id')==0)$fields.=',item_id';$sFields='';foreach($aAllowedFields as$field)if(substr_count($fields,$field)>0||!$bFields)$sFields.=$field.',';$sFields=substr($sFields,0,strlen($sFields)-1);}$sFields=icewarp_sanitize_db_sql($sFields);if($limit&&$_SESSION['DBTYPE']=='ODBC'){$limit=str_replace('LIMIT ','',$limit);$limit=explode(',',$limit);$stmt=$this->prepare('SELECT TOP '.intval($limit[1]).' '.$sFields.' FROM 
                  (SELECT TOP '.intval($limit[1]+$limit[0]).' '.$sFields.',ROW_NUMBER() OVER('.$orderBy.') as row
                  FROM item WHERE ('.$selector.$filter.') AND (NOT (flags & '.Item::FLAG_DELETED.' > 0)) '.$orderBy.') x
                  WHERE x.row BETWEEN '.intval($limit[0]+1).' and '.intval($limit[1]+$limit[0]));$values=array();}else{$stmt=$this->prepare('SELECT '.$sFields.' FROM item'.' WHERE '.$selector.$filter.' AND NOT (flags & ? > 0) '.$orderBy.$limit);$values=array(Item::FLAG_DELETED);}$stmt->execute($values);$items=array();while($row=$stmt->fetch()){$item=new$class($folder,isset($row['item_id'])?intval($row['item_id']):'',isset($row['rid'])?$row['rid']:'',isset($row['size'])?intval($row['size']):'',isset($row['date'])?$row['date']:'',isset($row['flags'])?intval($row['flags']):'',isset($row['header_from'])?$row['header_from']:'',isset($row['header_to'])?$row['header_to']:'',isset($row['subject'])?$row['subject']:'',isset($row['static_flags'])?intval($row['static_flags']):'',isset($row['priority'])?intval($row['priority']):'',isset($row['color'])?$row['color']:null,isset($row['smime_status'])?intval($row['smime_status']):'',(isset($row['has_attachment'])&&$row['has_attachment']=='T')?true:false,isset($row['body'])?$row['body']:null,isset($row['header_cc'])?$row['header_cc']:'',isset($row['header_bcc'])?$row['header_bcc']:'',isset($row['header_sms'])?$row['header_sms']:'',isset($row['sort_from'])?$row['sort_from']:'',isset($row['sort_to'])?$row['sort_to']:'',isset($row['sort_cc'])?$row['sort_cc']:'',isset($row['sort_bcc'])?$row['sort_bcc']:'',isset($row['sort_sms'])?$row['sort_sms']:'',isset($row['message_id'])?$row['message_id']:'');$items[$item->itemID]=$item;}$this->commit();return$items;}public function getFolderSelector($folder){if($folder->type=='V'){if($folder->folders)foreach($folder->folders as$fdr){$ids[]=$fdr->folderID;}$selector=' folder_id IN ( '.join(',',$ids).' ) ';}else{$selector=' folder_id = '.$folder->folderID.' ';}return$selector;}public function getItem($folder,$class,$itemID,$initialized=false){$row=$this->getItemRow($folder,$itemID,$initialized,$class);return new$class($folder,$itemID,$row['rid'],intval($row['size']),$row['date'],intval($row['flags']),$row['header_from'],$row['header_to'],$row['subject'],intval($row['static_flags']),intval($row['priority']),$row['color'],intval($row['smime_status']),($row['has_attachment']=='T')?true:false,($class=='RSSItem')?$row['body']:NULL,isset($row['header_cc'])?$row['header_cc']:'',isset($row['header_bcc'])?$row['header_bcc']:'',isset($row['header_sms'])?$row['header_sms']:'',isset($row['sort_from'])?$row['sort_from']:'',isset($row['sort_to'])?$row['sort_to']:'',isset($row['sort_cc'])?$row['sort_cc']:'',isset($row['sort_bcc'])?$row['sort_bcc']:'',isset($row['sort_sms'])?$row['sort_sms']:'',isset($row['message_id'])?$row['message_id']:'');}public function getItemRow($folder,$itemID,$initialized=false,$class=''){$selector=$this->getFolderSelector($folder);if(!$initialized)$this->transaction();$stmt=$this->prepare('SELECT item_id, rid, folder_id, size, date, flags,'.'header_from, header_to,header_cc,header_bcc,header_sms,subject,'.'static_flags, priority, color, smime_status,message_id,sort_from,sort_to,'.'sort_cc,sort_bcc,sort_sms,'.'has_attachment'.($class=='RSSItem'?', body':'').' FROM item'.' WHERE item_id = ? AND '.$selector);$stmt->execute(array($itemID));$row=$stmt->fetch();$stmt->closeCursor();if(!$initialized)$this->commit();if(!$row)throw new Exc('item_invalid_id');return$row;}public function countItems($folder,$flags=0,$positive=true,$filter='',$search=false){$selector=$this->getFolderSelector($folder);$filter=$this->composeFilter($filter,$search);$this->transaction();if($flags){$not=$positive?'':'NOT';$stmt=$this->prepare('SELECT COUNT(*) AS count '.'FROM item '.'WHERE '.$selector.$filter.' AND '.$not.' (flags & ? > 0) AND NOT (flags & ? > 0)');$stmt->execute(array(intval($flags),intval(Item::FLAG_DELETED)));}else{$stmt=$this->prepare('SELECT COUNT(*) AS count '.'FROM item '.'WHERE '.$selector.' AND NOT (flags & ? > 0) '.$filter);$stmt->execute(array(Item::FLAG_DELETED));}$row=$stmt->fetch();$stmt->closeCursor();$this->commit();if(!$row)throw new Exc('item_count_retrieve',$folder->name);return intval($row['count']);}public static function composeFilter($filter,$search){if($search&&$_SESSION['FULLTEXT']){switch($_SESSION['DBTYPE']){case'MYSQL':$filter=" AND (".($filter?$filter." OR ":"")."MATCH (body) AGAINST ('*".$search."*' IN BOOLEAN MODE))";break;default:$filter=" AND (".($filter?$filter." OR ":"")."body LIKE '%".$search."%')";break;}}else if($filter){$filter=' AND '.$filter;}$filter=icewarp_sanitize_db_sql($filter);return$filter;}public function getFoldersID($accountID){$this->transaction();$stmt=$this->prepare('SELECT folder_id, name, rights
								FROM folder
								WHERE account_id = ?');$stmt->execute(array($accountID));$folders=array();while($row=$stmt->fetch()){$folders[$row['name']]=array('folder_id'=>intval($row['folder_id']),'rights'=>intval($row['rights']));}$this->commit();return$folders;}public function createFolder($fields){if(strtolower($fields['name'])=='inbox')$fields['sync']='1';return$this->create('folder',$fields);}public function cleanup(){if($_SESSION['DBTYPE']=="SQLITE")$this->query('VACUUM');}public function deleteFolder($accountID,$folderID,$depth=0){$this->transaction();$stmt=$this->prepare('SELECT folder_id
								FROM folder
								WHERE parent_folder_id = ?');$stmt->execute(array($folderID));$folders=$stmt->fetchAll();if($folders)foreach($folders as$row){$this->deleteFolder($accountID,intval($row['folder_id']),$depth+1);}if($folders){$stmt=$this->prepare('DELETE FROM folder
									WHERE parent_folder_id = ?');$stmt->execute(array($folderID));}if(!$depth){$stmt=$this->prepare('DELETE FROM folder
									WHERE folder_id = ?');$stmt->execute(array($folderID));}$stmt=$this->prepare('DELETE FROM item
								WHERE folder_id = ?');$stmt->execute(array($folderID));$this->commit();if(!$depth)$this->deleteMessageDir($accountID,$folderID);}public function deleteItems(&$oFolder,$oItems=false){$this->transaction();if($oItems!==false){foreach($oItems as$oItem){$this->deleteItem($oFolder->account->accountID,$oFolder->folderID,$oItem->itemID,$this);$this->deleteMessage($oFolder->account->accountID,$oFolder->folderID,$oItem->itemID);}}else{$stmt=$this->prepare("DELETE FROM item WHERE folder_id = ?");$stmt->execute(array($oFolder->folderID));$this->deleteMessageDir($oFolder->account->accountID,$oFolder->folderID,true);}$this->commit();return true;}public function moveItems(&$oFrom,$oTo,$oItems=false,$aMovedID=false){$this->transaction();$cache['cache']=$this;if(!$oItems){$oI=$this->getItemsID($oFrom);if($oI)foreach($oI as$rid=>$itm){$item=false;$item->itemID=$itm['item_id'];$item->rid=$rid;$oItems[$itm['item_id']]=$item;}}if($oItems)foreach($oItems as$oItem){$this->updateItem($oItem->itemID,array('folder_id'=>$oTo->folderID,'rid'=>$aMovedID[$oItem->rid]),$cache);$this->deleteMessage($oFrom->account->accountID,$oFrom->folderID,$oItem->itemID);}$this->commit();return true;}public function copyItems(&$oFrom,$oTo,$oItems=false,$aCopiedID=false){$cache['cache']=$this;if($oItems)foreach($oItems as$oItem){$this->createItem(array('folder_id'=>$oTo->folderID,'rid'=>$aCopiedID[$oItem->rid],'size'=>$oItem->size,'date'=>$oItem->date,'flags'=>$oItem->flags,'header_from'=>$oItem->from,'header_to'=>$oItem->to,'subject'=>$oItem->subject,'static_flags'=>$oItem->staticFlags,'priority'=>intval($oItem->priority),'color'=>$oItem->color,'body'=>$oItem->body,'smime_status'=>$oItem->sMimeStatus,'has_attachment'=>$oItem->hasAttachments?'T':'F'),$cache);}return true;}public function updateFolder($folderID,$fields){$this->update('folder',array('folder_id'=>$folderID),$fields);}public function renameFolder($accountID,$folderID,$sOldFolderName,$sNewFolderName,$iDepth=0,$iLength=0,$stmtGetSubfolders=false,$stmtUpdateFolder=false){if(!$iDepth){$this->transaction();$stmtUpdateFolder=$this->prepare('UPDATE folder
        SET name = ?
        WHERE folder_id = ?');$stmtGetSubfolders=$this->prepare('SELECT folder_id,name
				FROM folder
				WHERE parent_folder_id = ?');$iLength=strlen($sOldFolderName);}$stmtUpdateFolder->execute(array($sNewFolderName,$folderID));$stmtGetSubfolders->execute(array($folderID));$aFolders=$stmtGetSubfolders->fetchAll();if($aFolders)foreach($aFolders as$aFolder){$sNewSubFolderName=$sNewFolderName.'/'.substr($aFolder['name'],$iLength+1);$this->renameFolder($accountID,intval($aFolder['folder_id']),$sNewSubFolderName,$aFolder['name'],$iDepth+1,strlen($sNewSubFolderName),$stmtGetSubfolders,$stmtUpdateFolder);}if(!$iDepth){$this->commit();}}public function getItemsID($folder,$transaction=true,&$duplicated=array(),$class='IMAPItem',$fields='item_id,rid,flags,color'){$selector=$this->getFolderSelector($folder);if($transaction)$this->transaction();$stmt=$this->prepare('SELECT '.$fields.'
								FROM item
								WHERE '.$selector);$stmt->execute();$items=array();while($row=$stmt->fetch()){if(isset($items[$row['rid']])){$duplicated[]=$row['item_id'];}if($class=='IMAPItem'){$row['rid']=IMAP::fixID($row['rid']);}$items[$row['rid']]=array('item_id'=>intval($row['item_id']),'flags'=>intval($row['flags']),'color'=>$row['color'],'header_from'=>$row['header_from']);}if($transaction)$this->commit();return$items;}public function createItem($fields,$cache=array()){return$this->create('item',$fields,$cache);}public function deleteItem($accountID,$folderID,$itemID,$cache=false){if($cache===false)$this->transaction();$stmt=$this->prepare('DELETE FROM item
								WHERE item_id = ?');$stmt->execute(array($itemID));if($cache===false)$this->commit();return$this->deleteMessage($accountID,$folderID,$itemID);}public function updateItem($itemID,$fields,$cache=array()){$this->update('item',array('item_id'=>$itemID),$fields,$cache);}private function create($table,$fields,$cache=array()){$columns=' ('.implode(',',array_keys($fields)).') ';$values='('.implode(',',array_fill(0,count($fields),'?')).')';if(!$cache['cache'])$this->transaction();$stmt=$this->prepare('INSERT INTO '.$table.$columns.'VALUES '.$values);$stmt->execute(array_values($fields));if(!$cache['cache'])$this->commit();return$this->getID();}private function update($table,$id,$fields,$cache=array()){$columns=implode('=?,',array_keys($fields)).'=? ';$selector=implode('=? AND ',array_keys($id)).'=?';if(!$cache['cache'])$this->transaction();$stmt=$this->prepare('UPDATE '.$table.' SET '.$columns.'WHERE '.$selector);try{$stmt->execute(array_merge(array_values($fields),array_values($id)));}catch(Exception$e){}if(!$cache['cache'])$this->commit();}public function markFolderItems($mailbox,$flag){$stmt=$this->prepare('UPDATE item
								SET flags = flags | ? WHERE folder_id = ?');$stmt->execute(array($flag,$mailbox));}public function unmarkFolderItems($mailbox,$flag){$stmt=$this->prepare('UPDATE item
								SET flags = flags & ? WHERE folder_id = ?');$stmt->execute(array($flag,$mailbox));}public function getMessage($accountID,$folderID,$itemID){$file=$this->getMessageFile($this->getMessageDir($accountID,$folderID),$itemID);if(!is_file($file))return false;@$return=file_get_contents($file);return$return;}public function createMessage($accountID,$folderID,$itemID,$message=false,$fileName=false){$dir=$this->getMessageDir($accountID,$folderID);if(!is_dir($dir))System::mkdir($dir);$file=$this->getMessageFile($dir,$itemID);if($fileName===false){if(substr($message,strlen($message)-4,4)!=CRLF.CRLF)$message.=CRLF.CRLF;@file_put_contents($file,$message);}else{copy($fileName,$file);}}public function editMessage($accountID,$folderID,$itemID,$message,$filename=false){$file=$this->getMessageFile($this->getMessageDir($accountID,$folderID),$itemID);if(!$filename)@file_put_contents($file,$message);else@copy($filename,$file);}public function deleteMessage($accountID,$folderID,$itemID){$file=$this->getMessageFile($this->getMessageDir($accountID,$folderID),$itemID);if(is_file($file))@unlink($file);return true;}public function moveMessage($accountID,$folderID,$itemID,$dstFolderID){$file=$this->getMessageFile($this->getMessageDir($accountID,$folderID),$itemID);if(is_file($file)){$dstDir=$this->getMessageDir($accountID,$dstFolderID);System::mkdir($dstDir);@rename($file,$this->getMessageFile($dstDir,$itemID));}}private function getMessageFile($dir,$itemID){return$this->paths->getMessageFile($dir,$itemID);}private function getMessageDir($accountID,$folderID,$empty=false){return$this->paths->getMessageDir($accountID,$folderID,$empty);}public function getMessagePath($accountID,$folderName,$itemID){return$this->paths->getMessagePath($accountID,$folderName,$itemID);}private function deleteMessageDir($accountID,$folderID,$empty=false){System::rmdir($this->getMessageDir($accountID,$folderID,$empty),$empty);}}?>
