<?php
 class Crypt_RSA extends Crypt_RSA_ErrorHandler{var$_math_obj;var$_enc_key;var$_dec_key;var$_public_key;var$_private_key;var$_hash_func='sha1';function Crypt_RSA($params=null,$wrapper_name='default',$error_handler=''){$this->setErrorHandler($error_handler);$obj=&Crypt_RSA_MathLoader::loadWrapper($wrapper_name);if($this->isError($obj)){$this->pushError($obj);return;}$this->_math_obj=&$obj;if(!is_null($params)){if(!$this->setParams($params)){return;}}}function&factory($params=null,$wrapper_name='default',$error_handler=''){$obj=&new Crypt_RSA($params,$wrapper_name,$error_handler);if($obj->isError()){return$obj->getLastError();}return$obj;}function setParams($params){if(!is_array($params)){$this->pushError('parameters must be passed to function as associative array',CRYPT_RSA_ERROR_WRONG_PARAMS);return false;}if(isset($params['enc_key'])){if(Crypt_RSA_Key::isValid($params['enc_key'])){$this->_enc_key=$params['enc_key'];}else{$this->pushError('wrong encryption key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return false;}}if(isset($params['dec_key'])){if(Crypt_RSA_Key::isValid($params['dec_key'])){$this->_dec_key=$params['dec_key'];}else{$this->pushError('wrong decryption key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return false;}}if(isset($params['private_key'])){if(Crypt_RSA_Key::isValid($params['private_key'])){if($params['private_key']->getKeyType()!='private'){$this->pushError('private key must have "private" attribute',CRYPT_RSA_ERROR_WRONG_KEY_TYPE);return false;}$this->_private_key=$params['private_key'];}else{$this->pushError('wrong private key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return false;}}if(isset($params['public_key'])){if(Crypt_RSA_Key::isValid($params['public_key'])){if($params['public_key']->getKeyType()!='public'){$this->pushError('public key must have "public" attribute',CRYPT_RSA_ERROR_WRONG_KEY_TYPE);return false;}$this->_public_key=$params['public_key'];}else{$this->pushError('wrong public key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return false;}}if(isset($params['hash_func'])){if(!function_exists($params['hash_func'])){$this->pushError('cannot find hash function with name ['.$params['hash_func'].']',CRYPT_RSA_ERROR_WRONG_HASH_FUNC);return false;}$this->_hash_func=$params['hash_func'];}return true;}function encrypt($plain_data,$key=null){$enc_data=$this->encryptBinary($plain_data,$key);if($enc_data!==false){return base64_encode($enc_data);}return false;}function encryptBinary($plain_data,$key=null){if(is_null($key)){$key=$this->_enc_key;}else if(!Crypt_RSA_Key::isValid($key)){$this->pushError('invalid encryption key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return false;}$plain_data.="\x01";$plain_data=$this->_math_obj->bin2int($plain_data);$exp=$this->_math_obj->bin2int($key->getExponent());$modulus=$this->_math_obj->bin2int($key->getModulus());$data_len=$this->_math_obj->bitLen($plain_data);$chunk_len=$key->getKeyLength()-1;$block_len=(int)ceil($chunk_len/8);$curr_pos=0;$enc_data='';while($curr_pos<$data_len){$tmp=$this->_math_obj->subint($plain_data,$curr_pos,$chunk_len);$enc_data.=str_pad($this->_math_obj->int2bin($this->_math_obj->powmod($tmp,$exp,$modulus)),$block_len,"\0");$curr_pos+=$chunk_len;}return$enc_data;}function decrypt($enc_data,$key=null){$enc_data=base64_decode($enc_data);return$this->decryptBinary($enc_data,$key);}function decryptBinary($enc_data,$key=null){if(is_null($key)){$key=$this->_dec_key;}else if(!Crypt_RSA_Key::isValid($key)){$this->pushError('invalid decryption key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return false;}$exp=$this->_math_obj->bin2int($key->getExponent());$modulus=$this->_math_obj->bin2int($key->getModulus());$data_len=strlen($enc_data);$chunk_len=$key->getKeyLength()-1;$block_len=(int)ceil($chunk_len/8);$curr_pos=0;$bit_pos=0;$plain_data=$this->_math_obj->bin2int("\0");while($curr_pos<$data_len){$tmp=$this->_math_obj->bin2int(substr($enc_data,$curr_pos,$block_len));$tmp=$this->_math_obj->powmod($tmp,$exp,$modulus);$plain_data=$this->_math_obj->bitOr($plain_data,$tmp,$bit_pos);$bit_pos+=$chunk_len;$curr_pos+=$block_len;}$result=$this->_math_obj->int2bin($plain_data);$tail=ord($result{strlen($result)-1});if($tail!=1){$this->pushError("Error tail of decrypted text = {$tail}. Expected 1",CRYPT_RSA_ERROR_WRONG_TAIL);return false;}return substr($result,0,-1);}function createSign($document,$private_key=null,$hash_func=null){if(is_null($private_key)){$private_key=$this->_private_key;}else if(!Crypt_RSA_Key::isValid($private_key)){$this->pushError('invalid private key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return false;}if($private_key->getKeyType()!='private'){$this->pushError('signing key must be private',CRYPT_RSA_ERROR_NEED_PRV_KEY);return false;}if(is_null($hash_func)){$hash_func=$this->_hash_func;}if(!function_exists($hash_func)){$this->pushError("cannot find hash function with name [$hash_func]",CRYPT_RSA_ERROR_WRONG_HASH_FUNC);return false;}return$this->encrypt($hash_func($document),$private_key);}function validateSign($document,$signature,$public_key=null,$hash_func=null){if(is_null($public_key)){$public_key=$this->_public_key;}else if(!Crypt_RSA_Key::isValid($public_key)){$this->pushError('invalid public key. It must be an object of Crypt_RSA_Key class',CRYPT_RSA_ERROR_WRONG_KEY);return null;}if($public_key->getKeyType()!='public'){$this->pushError('validating key must be public',CRYPT_RSA_ERROR_NEED_PUB_KEY);return null;}if(is_null($hash_func)){$hash_func=$this->_hash_func;}if(!function_exists($hash_func)){$this->pushError("cannot find hash function with name [$hash_func]",CRYPT_RSA_ERROR_WRONG_HASH_FUNC);return null;}return$hash_func($document)==$this->decrypt($signature,$public_key);}}?>
