<?php
 require_once'inc/crypt/rsa/ErrorHandler.php';require_once'inc/crypt/rsa/MathLoader.php';require_once'inc/crypt/rsa/Key.php';class Crypt_RSA_KeyPair extends Crypt_RSA_ErrorHandler{var$_math_obj;var$_key_len;var$_public_key;var$_private_key;var$_random_generator;var$_attrs;function _get_attr_names(){return array('version','n','e','d','p','q','dmp1','dmq1','iqmp');}function _ASN1Parse($str,&$pos,&$err_handler){$max_pos=strlen($str);if($max_pos<2){$err_handler->pushError("ASN.1 string too short");return false;}$tag=ord($str[$pos++])&0x1f;if($tag==0x1f){$tag=0;do{$n=ord($str[$pos++]);$tag<<=7;$tag|=$n&0x7f;}while(($n&0x80)&&$pos<$max_pos);}if($pos>=$max_pos){$err_handler->pushError("ASN.1 string too short");return false;}$len=ord($str[$pos++]);if($len&0x80){$n=$len&0x1f;$len=0;while($n--&&$pos<$max_pos){$len<<=8;$len|=ord($in[$pos++]);}}if($pos>=$max_pos||$len>$max_pos-$pos){$err_handler->pushError("ASN.1 string too short");return false;}$str=substr($str,$pos,$len);return array('tag'=>$tag,'str'=>$str,);}function _ASN1ParseInt($str,&$pos,&$err_handler){$tmp=Crypt_RSA_KeyPair::_ASN1Parse($str,$pos,$err_handler);if($err_handler->isError()){return false;}if($tmp['tag']!=0x02){$errstr=sprintf("wrong ASN tag value: 0x%02x. Expected 0x02 (INTEGER)",$tmp['tag']);$err_handler->pushError($errstr);return false;}$pos+=strlen($tmp['str']);return strrev($tmp['str']);}function _ASN1Store($str,$tag,$is_constructed=false,$is_private=false){$out='';$tag_ext=($is_constructed?0x20:0)|($is_private?0xc0:0);if($tag<0x1f){$out.=chr($tag|$tag_ext);}else{$out.=chr($tag_ext|0x1f);$tmp=chr($tag&0x7f);$tag>>=7;while($tag){$tmp.=chr(($tag&0x7f)|0x80);$tag>>=7;}$out.=strrev($tmp);}$len=strlen($str);if($len<0x7f){$out.=chr($len);}else{$tmp='';$n=0;while($len){$tmp.=chr($len&0xff);$len>>=8;$n++;}$out.=chr($n|0x80);$out.=strrev($tmp);}return$out.$str;}function _ASN1StoreInt($str){$str=strrev($str);return Crypt_RSA_KeyPair::_ASN1Store($str,0x02);}function Crypt_RSA_KeyPair($key_len,$wrapper_name='default',$error_handler='',$random_generator=null){$this->setErrorHandler($error_handler);$obj=&Crypt_RSA_MathLoader::loadWrapper($wrapper_name);if($this->isError($obj)){$this->pushError($obj);return;}$this->_math_obj=&$obj;if(!$this->setRandomGenerator($random_generator)){return;}if(is_array($key_len)){$rsa_attrs=$key_len;$attr_names=$this->_get_attr_names();foreach($attr_names as$attr){if(!isset($rsa_attrs[$attr])){$this->pushError("missing required RSA attribute [$attr]");return;}${$attr}=$this->_math_obj->bin2int($rsa_attrs[$attr]);}if(!$this->_math_obj->isPrime($p)){$this->pushError("[p] must be prime");return;}if(!$this->_math_obj->isPrime($q)){$this->pushError("[q] must be prime");return;}$n1=$this->_math_obj->mul($p,$q);if($this->_math_obj->cmpAbs($n,$n1)){$this->pushError("n != p * q");return;}$p1=$this->_math_obj->dec($p);$q1=$this->_math_obj->dec($q);$p1q1=$this->_math_obj->mul($p1,$q1);$ed=$this->_math_obj->mul($e,$d);$one=$this->_math_obj->mod($ed,$p1q1);if(!$this->_math_obj->isOne($one)){$this->pushError("e * d != 1 mod (p-1)*(q-1)");return;}$dmp=$this->_math_obj->mod($d,$p1);if($this->_math_obj->cmpAbs($dmp,$dmp1)){$this->pushError("dmp1 != d mod (p-1)");return;}$dmq=$this->_math_obj->mod($d,$q1);if($this->_math_obj->cmpAbs($dmq,$dmq1)){$this->pushError("dmq1 != d mod (q-1)");return;}$q1=$this->_math_obj->invmod($iqmp,$p);if($this->_math_obj->cmpAbs($q,$q1)){$this->pushError("iqmp != 1/q mod p");return;}$public_key=&new Crypt_RSA_Key($rsa_attrs['n'],$rsa_attrs['e'],'public',$wrapper_name,$error_handler);if($public_key->isError()){$this->pushError($public_key->getLastError());return;}$private_key=&new Crypt_RSA_Key($rsa_attrs['n'],$rsa_attrs['d'],'private',$wrapper_name,$error_handler);if($private_key->isError()){$this->pushError($private_key->getLastError());return;}$this->_public_key=$public_key;$this->_private_key=$private_key;$this->_key_len=$public_key->getKeyLength();$this->_attrs=$rsa_attrs;}else{if(!$this->generate($key_len)){return;}}}function&factory($key_len,$wrapper_name='default',$error_handler='',$random_generator=null){$obj=&new Crypt_RSA_KeyPair($key_len,$wrapper_name,$error_handler,$random_generator);if($obj->isError()){return$obj->getLastError();}return$obj;}function generate($key_len=null){if(is_null($key_len)){$key_len=$this->_key_len;if(is_null($key_len)){$this->pushError('missing key_len parameter',CRYPT_RSA_ERROR_MISSING_KEY_LEN);return false;}}if($key_len<8){$key_len=8;}$this->_key_len=$key_len;$e=$this->_math_obj->bin2int("\x01\x00\x01");$p_len=intval(($key_len+1)/2);$q_len=$key_len-$p_len;$p1=$q1=0;do{do{$p=$this->_math_obj->getPrime($p_len,$this->_random_generator);$p1=$this->_math_obj->dec($p);$tmp=$this->_math_obj->GCD($e,$p1);}while(!$this->_math_obj->isOne($tmp));do{$q=$this->_math_obj->getPrime($q_len,$this->_random_generator);$q1=$this->_math_obj->dec($q);$tmp=$this->_math_obj->GCD($e,$q1);}while(!$this->_math_obj->isOne($tmp)&&!$this->_math_obj->cmpAbs($q,$p));if($this->_math_obj->cmpAbs($p,$q)<0){$tmp=$p;$p=$q;$q=$tmp;$tmp=$p1;$p1=$q1;$q1=$tmp;}$n=$this->_math_obj->mul($p,$q);}while($this->_math_obj->bitLen($n)!=$key_len);$pq=$this->_math_obj->mul($p1,$q1);$d=$this->_math_obj->invmod($e,$pq);$dmp1=$this->_math_obj->mod($d,$p1);$dmq1=$this->_math_obj->mod($d,$q1);$iqmp=$this->_math_obj->invmod($q,$p);$this->_attrs=array('version'=>"\x00",'n'=>$this->_math_obj->int2bin($n),'e'=>$this->_math_obj->int2bin($e),'d'=>$this->_math_obj->int2bin($d),'p'=>$this->_math_obj->int2bin($p),'q'=>$this->_math_obj->int2bin($q),'dmp1'=>$this->_math_obj->int2bin($dmp1),'dmq1'=>$this->_math_obj->int2bin($dmq1),'iqmp'=>$this->_math_obj->int2bin($iqmp),);$n=$this->_attrs['n'];$e=$this->_attrs['e'];$d=$this->_attrs['d'];$obj=&new Crypt_RSA_Key($n,$e,'public',$this->_math_obj->getWrapperName(),$this->_error_handler);if($obj->isError()){$this->pushError($obj->getLastError());return false;}$this->_public_key=&$obj;$obj=&new Crypt_RSA_Key($n,$d,'private',$this->_math_obj->getWrapperName(),$this->_error_handler);if($obj->isError()){$this->pushError($obj->getLastError());return false;}$this->_private_key=&$obj;return true;}function getPublicKey(){return$this->_public_key;}function getPrivateKey(){return$this->_private_key;}function setRandomGenerator($random_generator=null){static$default_random_generator=null;if(is_string($random_generator)){if(!function_exists($random_generator)){$this->pushError("can't find random generator function with name [{$random_generator}]");return false;}$this->_random_generator=$random_generator;}else{$this->_random_generator=is_null($default_random_generator)?($default_random_generator=create_function('','$a=explode(" ",microtime());return(int)($a[0]*1000000);')):$default_random_generator;}return true;}function getKeyLength(){return$this->_key_len;}static function&fromPEMString($str,$wrapper_name='default',$error_handler=''){if(isset($this)){if($wrapper_name=='default'){$wrapper_name=$this->_math_obj->getWrapperName();}if($error_handler==''){$error_handler=$this->_error_handler;}}$err_handler=&new Crypt_RSA_ErrorHandler;$err_handler->setErrorHandler($error_handler);if(!preg_match('/-----BEGIN RSA PRIVATE KEY-----([^-]+)-----END RSA PRIVATE KEY-----/',$str,$matches)){$err_handler->pushError("can't find RSA private key in the string [{$str}]");return$err_handler->getLastError();}$str=base64_decode($matches[1]);$pos=0;$tmp=Crypt_RSA_KeyPair::_ASN1Parse($str,$pos,$err_handler);if($err_handler->isError()){return$err_handler->getLastError();}if($tmp['tag']!=0x10){$errstr=sprintf("wrong ASN tag value: 0x%02x. Expected 0x10 (SEQUENCE)",$tmp['tag']);$err_handler->pushError($errstr);return$err_handler->getLastError();}$attr_names=Crypt_RSA_KeyPair::_get_attr_names();$n=sizeof($attr_names);$rsa_attrs=array();for($i=0;$i<$n;$i++){$tmp=Crypt_RSA_KeyPair::_ASN1ParseInt($str,$pos,$err_handler);if($err_handler->isError()){return$err_handler->getLastError();}$attr=$attr_names[$i];$rsa_attrs[$attr]=$tmp;}$keypair=&new Crypt_RSA_KeyPair($rsa_attrs,$wrapper_name,$error_handler);if($keypair->isError()){return$keypair->getLastError();}return$keypair;}function toPEMString(){$str='';$attr_names=$this->_get_attr_names();$n=sizeof($attr_names);$rsa_attrs=$this->_attrs;for($i=0;$i<$n;$i++){$attr=$attr_names[$i];if(!isset($rsa_attrs[$attr])){$this->pushError("Cannot find value for ASN.1 attribute [$attr]");return false;}$tmp=$rsa_attrs[$attr];$str.=Crypt_RSA_KeyPair::_ASN1StoreInt($tmp);}$str=Crypt_RSA_KeyPair::_ASN1Store($str,0x10,true);$str=base64_encode($str);$str=chunk_split($str,64,"\n");return"-----BEGIN RSA PRIVATE KEY-----\n$str-----END RSA PRIVATE KEY-----\n";}function isEqual($key_pair){$attr_names=$this->_get_attr_names();foreach($attr_names as$attr){if($this->_attrs[$attr]!=$key_pair->_attrs[$attr]){return false;}}return true;}}?>
