<?php
 abstract class Folder{const RIGHT_ADMIN=0x01;const RIGHT_FOLDER_WRITE=0x02;const RIGHT_DELETE=0x04;const RIGHT_WRITE=0x08;const RIGHT_FOLDER_READ=0x10;const RIGHT_READ=0x20;const RIGHT_MODIFY=0x80;const RIGHT_FOLDER_DELETE=0x100;const RIGHT_FOLDER_MODIFY=0x200;const RIGHT_EXPUNGE=0x400;const RIGHT_POST=0x800;const RIGHT_SEEN=0x40;const RIGHT_REMOVE=0x1000;const RIGHT_BITS=0x2000;const RIGHT_INHERITED=0x4000;const DEFAULT_RIGHTS=958;public$name;public$rights;public$rightsUpdated;public$gw;protected function __construct($name,$rights){$this->name=$name;$this->rights=$rights;if($type=$this->isDefault()){$this->isDefault=true;$this->defaultType=$type;}}protected static function create($name){}abstract protected function delete();abstract protected function rename($newName);abstract public function deleteItems($oItems=false);abstract public function moveItems(&$oFolder,$oItems=false);abstract public function copyItems(&$oFolder,$oItems=false);protected function getItems($filter,$orderBy,$offset,$limit){}protected function getItem($itemID){}final public function deleteItem($itemID,$cache=array()){$item=&$this->getItem($itemID,$cache);if($this->gw)$cache=false;return$item->delete($cache);}public function transferItems(&$oFolder,$oItems=false,$copy=false){if($oFolder->itemClassName=='POP3Item'){throw new Exc($copy?'item_copy':'item_move');}if($oItems===false){$oItems=$this->getItems();}foreach($oItems as$item){$fileName=$item->getMessageFile();if(!file_exists($fileName)){$item->autoCreateMessage($fileName);}$newID=$oFolder->createItem(false,$fileName,true);if($oFolder->itemClassName=='IMAPItem'){$strFlags=IMAPItem::encodeFlags($item->flags);$strFlags=str_replace("\\Flagged","",$strFlags);$targetIMAP=IMAP::instance($oFolder->account);$targetIMAP->setFlags($oFolder->name,$newID,$strFlags);}$aResult[$item->rid]=$newID;}if(!$copy){$this->deleteItems($oItems,true);}return$aResult;}static public function checkTransfer($oSource,&$oDest){if($oDest->type=='V'){$oDest=$oDest->getPrimary();}if($oSource->account->accountID!=$oDest->account->accountID){return true;}else{return false;}}static public function checkRights(&$folder,$right){if(!$folder->rights){$folder->rights=$folder->getMyRights($folder->name);}if($folder->rights&$right){return true;}else{throw new Exc('folder_insufficient_rights','Insufficient folder right ('.$right.') :'.$folder->name);}}static public function checkName($sFolderName){if(!$sFolderName){throw new Exc('folder_missing_name');}if($sFolderName!=self::trimFolder($sFolderName)){throw new Exc('folder_name_bad_char',$sFolderName);}if(preg_match("([\:\*\?\"\<\>\|])",$sFolderName,$matches)){throw new Exc('folder_name_bad_char',$sFolderName);}if(mb_strlen($sFolderName,'UTF-8')>255){throw new Exc('folder_name_too_long',$sFolderName);}}static public function checkRename($sOldName,$sNewName){self::checkName($sNewName);$sParent=substr($sNewName,0,strrpos($sNewName,'/'));$aOldNames=explode('/',$sOldName);$aNewNames=explode('/',$sNewName);if((count($aNewNames)>count($aOldNames))&&(strpos($sParent,$sOldName)!==false)){throw new Exc('folder_move_to_subfolder',$sOldName.'=>'.$sNewName);}if($sParent==$sOldName){throw new Exc('folder_move_to_self',$sOldName);}if(strpos($sOldName,'__@@VIRTUAL@@__')!==strpos($sNewName,'__@@VIRTUAL@@__')){throw new Exc('folder_move_error','Move virtual folder to normal folder or vice versa,old name: '.$sOldName.' new name:'.$sNewName);}}public function trimFolder($sName){if(($sParentDelimiter=strrpos($sName,'/'))!==false){$sToTrim=substr($sName,$sParentDelimiter+1);$sToTrim=trim($sToTrim);$sFolderName=substr($sName,0,$sParentDelimiter+1).$sToTrim;return$sFolderName;}else{return trim($sName);}}abstract protected function countItems($flags=0);public function getAcl(){return array($this->account->accountID=>Folder::DEFAULT_RIGHTS);}public function setAcl($aList){return true;}public function getMyRights($folder){return Folder::DEFAULT_RIGHTS;}static final public function rightsToBitValue($clientRights){$wmRights=0;foreach(str_split($clientRights)as$right){switch($right){case'a':$wmRights|=Folder::RIGHT_ADMIN;break;case'r':$wmRights|=Folder::RIGHT_READ;break;case'i':$wmRights|=Folder::RIGHT_WRITE;break;case'w':$wmRights|=Folder::RIGHT_MODIFY;break;case't':$wmRights|=Folder::RIGHT_DELETE;break;case'l':$wmRights|=Folder::RIGHT_FOLDER_READ;break;case'k':$wmRights|=Folder::RIGHT_FOLDER_WRITE;break;case'x':$wmRights|=Folder::RIGHT_FOLDER_MODIFY;$wmRights|=Folder::RIGHT_FOLDER_DELETE;break;case'~':$wmRights|=Folder::RIGHT_REMOVE;break;case'8':$wmRights|=Folder::RIGHT_INHERITED;break;}}return$wmRights;}static final public function rightsToString($rights,$name=''){if(strtolower($name)=='inbox'){return'riwtlka';}$sRights.=($rights&Folder::RIGHT_READ)?'r':'';$sRights.=($rights&Folder::RIGHT_WRITE)?'i':'';$sRights.=($rights&Folder::RIGHT_MODIFY)?'w':'';$sRights.=($rights&Folder::RIGHT_DELETE)?'t':'';$sRights.=($rights&Folder::RIGHT_FOLDER_READ)?'l':'';$sRights.=($rights&Folder::RIGHT_FOLDER_WRITE)?'k':'';$sRights.=(($rights&Folder::RIGHT_FOLDER_MODIFY)||($rights&Folder::RIGHT_FOLDER_DELETE))?'x':'';$sRights.=($rights&Folder::RIGHT_ADMIN)?'a':'';return$sRights;}static public function createDual($account,$folder){if($account->account){$type='gw';$dualAccount=$account->account;$dualAccount->getFolders();$aFoldersCurrent=$dualAccount->folders[$type];}else if($account->gwAccount){$type='main';$dualAccount=$account->gwAccount;$account->getFolders();$aFoldersCurrent=$account->folders[$type];}else{return;}$aFolders=explode('/',$folder);$aFolders=array_reverse($aFolders);$iCount=count($aFolders);foreach($aFolders as$key=>$fname){$sName='';for($i=0;$i<($iCount-$key);$i++){$sName.=$aFolders[$iCount-$i-1].(($i==$iCount-$key-1)?'':'/');}if(isset($aFoldersCurrent[$sName])){$sParentFolder=$sName;break;}else{if($sName==$folder){$sNewFolder=$sName;}else{$aFoldersCreate[]=$sName;}}}if(is_array($aFoldersCreate)){$aFoldersCreate=array_reverse($aFoldersCreate);foreach($aFoldersCreate as$key=>$treefolder){$result=$account->createFolder(array('name'=>$treefolder,'type'=>'M','virtual'=>false));$dualAcl=$dualAccount->getAcl($treefolder);$dualInherited=$dualAccount->isInheritedACL($treefolder,$dualAcl);if(!$dualInherited){try{$account->setAcl($dualAcl,$treefolder,false);}catch(Exc$e){if(is_array($dualAcl)){throw$e;}}}}}}public function edit($parameters){$sNewName=$parameters['name'];$sNewChannel=$parameters['channel'];$sSubscribed=$parameters['subscription'];$sDefault=$parameters['default'];$oAccount=&$this->account;$default=$this->isDefault();if($sNewName){Folder::checkName($sNewName);$this->rename($sNewName);if($default){$this->setDefault($this->defaultType,true);}}$sName=$this->name;if(isset($sSubscribed)){$this->setSubscription($sSubscribed);}if($sDefault&&!$sNewName){$this->setDefault($sDefault);}}public function markItems(){throw new Exc('folder_mark_non_mail',$this->name);}public function unmarkItems(){throw new Exc('folder_mark_non_mail',$this->name);}public function getType(){if($this->type=='V'){return$this->contentType;}else{return$this->type;}}public function isDefault(){$list=User::getDefaultFolderList();if(is_array($list)&&in_array($this->name,$list)){return array_search($this->name,$list);}else{return false;}}public function setDefault($type,$updateSettings=true){$oldDefault=User::getDefaultFolder($type);User::setDefaultFolder($this->name,$type);$this->account->folders['main'][$oldDefault]->isDefault=false;unset($this->account->folders['main'][$oldDefault]->defaultType);$this->account->folders['main'][$this->name]->isDefault=true;$this->account->folders['main'][$this->name]->defaultType=$type;$this->isDefault=true;$this->defaultType=$type;if($updateSettings){$data=Storage::getUserData();$default_folders=&$data['@childnodes']['default_folders'][0]['@childnodes']['item'][0]['@childnodes'];$mailFolders=array('D'=>'drafts','S'=>'sent','H'=>'trash');$default_folders[$mailFolders[$type]][0]['@value']=$this->account->accountID.'/'.$this->name;$str=Tools::makeXMLStringFromTree($data,'settings');Storage::setUserDataStr($str,'default_folders');}}public function checkACLConsistence($acl_visible,$acl_invisible,&$acl){if($acl_visible)foreach($acl_visible as$key=>$val){$match1[$key]=Folder::rightsToString($val);}if($acl_invisible)foreach($acl_invisible as$key=>$val){$match2[$key]=Folder::rightsToString($val);}if($match1!=$match2){if($acl_visible)foreach($acl_visible as$key=>$val){if(!isset($acl[$key])){$acl[$key]=$val;}}if($acl_invisible)foreach($acl_invisible as$key=>$val){if(!isset($acl_visible[$key])&&!isset($acl[$key])){$acl[$key]=Folder::RIGHT_REMOVE;}}return false;}return true;}}?>
