<?php
 class IMAPFolder extends CacheFolder{public$type;public function __construct(&$account,$folderID,$name,$rights,$sync){parent::__construct($account,$folderID,$name,$rights,$sync);$this->type='M';$this->gw=false;$this->itemClassName='IMAPItem';}public static function create($account,$name){Folder::createDual($account,$name);$imap=IMAP::instance($account);$rights=$imap->createMailbox($name,$account->accountID);$rights=self::decodeRights($rights);$folderID=parent::create($account,$name,$rights);return new IMAPFolder($account,$folderID,$name,$rights,false);}public function delete($bDeleteDual=true){$account=$this->account;$oFolderParent=$this->getParent($account);$folders=krsort($account->folders["main"]);$imap=IMAP::instance($account);@$imap->deleteMailbox($this->name);parent::delete();unset($account->folders['main'][$this->name]);if(($oGWFolder=$this->getGWFolder($this->name))&&$bDeleteDual){$oGWFolder->delete(false);}if($oFolderParent){$oParentGWFolder=$this->getGWFolder($oFolderParent->name);if(!($oParentGWFolder===false))$bDeleteFlag=true;else$bDeleteFlag=false;$oChildern=$oFolderParent->getChildern($account);if($oChildern===false&&$deleteFlag){$oGWFolder=$this->getGWFolder($oFolderParent->name);if($oGWFolder->type!='M')$oFolderParent->delete();}}}public function rename($newName,$bRenameDual=true){$account=$this->account;Folder::checkRename($this->name,$newName);$imap=IMAP::instance($account);$type='M';$oldName=$this->name;$parent=substr($newName,0,strrpos($newName,$imap->delimiter));if($parent){try{$oFolder=$account->getFolder($parent,$type);}catch(Exc$e){$imap->createMailbox($parent);}}$imap->renameMailbox($this->name,$newName);parent::rename($newName);if(($oGWFolder=$this->getGWFolder($oldName))&&$bRenameDual){$oGWFolder->rename($newName,false);}}public function deleteItems($oItems=false,$bNoCache=false){Folder::checkRights($this,Folder::RIGHT_DELETE);$account=$this->account;$imap=IMAP::instance($account);if($oItems===false){$sequence=$this->getItemsSequence();$imap->deleteItems($this,$oItems,$sequence);}else{$imap->deleteItems($this,$oItems);}if(!$bNoCache){return parent::deleteItems($oItems);}}public function moveItems(&$oFolder,$oItems=false){Folder::checkRights($oFolder,Folder::RIGHT_WRITE);Folder::checkRights($this,Folder::RIGHT_DELETE);if(Folder::checkTransfer($this,$oFolder)){$aMovedID=Folder::transferItems($oFolder,$oItems);}else{$account=$this->account;$imap=IMAP::instance($account);if($oItems===false){$sequence=$this->getItemsSequence();$aMovedID=$imap->moveItems($this,$oFolder,$oItems,false,$sequence);}else{$aMovedID=$imap->moveItems($this,$oFolder,$oItems);}}return parent::moveItems($oFolder,$oItems,$aMovedID);}public function copyItems(&$oFolder,$oItems=false){Folder::checkRights($oFolder,Folder::RIGHT_WRITE);if(Folder::checkTransfer($this,$oFolder)){$aCopiedID=Folder::transferItems($oFolder,$oItems,true);}else{$imap=IMAP::instance($this->account);if($oItems===false){$sequence=$this->getItemsSequence();$aCopiedID=$imap->moveItems($this,$oFolder,$oItems,true,$sequence);}else{$aCopiedID=$imap->moveItems($this,$oFolder,$oItems,true);}}return parent::copyItems($oFolder,$oItems,$aCopiedID);}public function setAcl($aList,$bSetDual=true){$this->account->setAcl($aList,$this->name,$bSetDual);}public function getAcl(){$this->acl=$this->account->getAcl($this->name);return$this->acl;}public function getMyRights(){return$this->account->getMyRights($this->name);}public static function decodeRights($imapRights){$wmRights=0;if(strpos($imapRights,'a')!==false){$wmRights|=Folder::RIGHT_ADMIN;}if(strpos($imapRights,'r')!==false){$wmRights|=Folder::RIGHT_READ;}if(strpos($imapRights,'i')!==false){$wmRights|=Folder::RIGHT_WRITE;}if(strpos($imapRights,'w')!==false&&strpos($imapRights,'s')!==false){$wmRights|=Folder::RIGHT_WRITE;$wmRights|=Folder::RIGHT_MODIFY;}if((strpos($imapRights,'t')!==false&&strpos($imapRights,'e')!==false)||strpos($imapRights,'d')!==false){$wmRights|=Folder::RIGHT_DELETE;$wmRights|=Folder::RIGHT_EXPUNGE;}if(strpos($imapRights,'l')!==false){$wmRights|=Folder::RIGHT_FOLDER_READ;}if(strpos($imapRights,'k')!==false||strpos($imapRights,'c')!==false){$wmRights|=Folder::RIGHT_FOLDER_WRITE;}if(strpos($imapRights,'x')!==false||strpos($imapRights,'c')!==false){$wmRights|=Folder::RIGHT_FOLDER_DELETE;$wmRights|=Folder::RIGHT_FOLDER_MODIFY;}if(strpos($imapRights,'s')!==false){$wmRights|=Folder::RIGHT_SEEN;}if(strpos($imapRights,'p')!==false){$wmRights|=Folder::RIGHT_POST;}if(strpos($imapRights,'8')!==false){$wmRights|=Folder::RIGHT_INHERITED;}return$wmRights;}public static function encodeRights($wmRights){$rights='';if($wmRights&Folder::RIGHT_READ){$rights.='r';}if($wmRights&Folder::RIGHT_WRITE){$rights.='i';$rights.='p';}if($wmRights&Folder::RIGHT_MODIFY){$rights.='s';$rights.='w';}if($wmRights&Folder::RIGHT_DELETE){$rights.='et';}if($wmRights&Folder::RIGHT_FOLDER_READ){$rights.='l';}if($wmRights&Folder::RIGHT_FOLDER_WRITE){$rights.='k';}if($wmRights&Folder::RIGHT_FOLDER_DELETE||$wmRights&Folder::RIGHT_FOLDER_MODIFY){$rights.='x';}if($wmRights&Folder::RIGHT_ADMIN)$rights.='a';return$rights;}public function getItems($aFilterTag=array('tag'=>'*')){$filter=$aFilterTag['sql'];$orderBy=$aFilterTag['orderby'];$offset=$aFilterTag['offset'];$limit=$aFilterTag['limit'];$fields=$aFilterTag['tag'];$search=$aFilterTag['fulltext'];if($fields&&!strstr($fields,'rid'))$fields.=',rid';return parent::getItems('IMAPItem',$filter,$orderBy,$offset,$limit,$fields,$search);}public function getItem($itemID,$cache=array()){if(!$cache['cache'])$cache=false;return parent::getItem('IMAPItem',$itemID,$cache);}public function createItem($message=false,$file=false,$bNoCache=false){return IMAPItem::create($this,$message,$file,$bNoCache);}public function markItems($flag){parent::markItems($flag);$account=$this->account;$imap=IMAP::instance($account);$sequence=$this->getItemsSequence();$imap->setFlags($this->name,$sequence,IMAPItem::encodeFlags($flag));}public function unmarkItems($flag){parent::unmarkItems($flag);$account=$this->account;$imap=IMAP::instance($account);$sequence=$this->getItemsSequence();$imap->setFlags($this->name,$sequence,IMAPItem::encodeFlags($flag));}public function sync(){try{$account=$this->account;@file_put_contents($_SESSION['USERDIR'].SETTINGS_FOLDER.UNAVAILABLE_FILE,1);$imap=IMAP::instance($account);$aItemsID=$imap->getItemsID($this->name);$oldExecutionTime=ini_alter('max_execution_time',MAX_EXECUTION_TIME);parent::sync($this->itemClassName,$aItemsID,$this);@unlink($_SESSION['USERDIR'].SETTINGS_FOLDER.UNAVAILABLE_FILE);ini_set('max_execution_time',$oldExecutionTime);}catch(Exc$e){}catch(Exception$e){}}public function search($sPhrase,$aFilterTag){if($_SESSION['FULLTEXT'])return parent::search($sPhrase,$aFilterTag);else{$imap=IMAP::instance($this->account);$result=$imap->search($this->name,$sPhrase);if($result)foreach($result as$key=>$val){$result[$key]=IMAP::fixID($val);}}$aFilterTag=$this->updateSearchFilter($result,$aFilterTag);$result=$this->getItems($aFilterTag);return$result;}private function getItemsSequence(){$cache=Cache::instance($_SESSION['user']);$seq=$cache->query('SELECT MIN(rid) AS lower,MAX(rid) AS upper FROM item'.' WHERE folder_id = '.$this->folderID);$result=$seq->fetch();return$result['lower'].':'.$result['upper'];}}?>
